"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _providers = _interopRequireDefault(require("./providers"));

var _BaiduMapProvider = _interopRequireDefault(require("./providers/BaiduMapProvider"));

var _en_US = _interopRequireDefault(require("antd-mobile/lib/locale-provider/en_US"));

var _antdMobile = require("antd-mobile");

var _ApplicationProvider = _interopRequireDefault(require("./providers/ApplicationProvider"));

var _TemplateProvider = _interopRequireDefault(require("./template/TemplateProvider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var getAntLocale = function getAntLocale() {
  if (navigator.language.startsWith('zh')) {
    return null;
  }

  return _en_US["default"];
}; // wechat


function isWeixin() {
  var ua = navigator.userAgent.toLowerCase();

  if (ua.match(/MicroMessenger/i) == "micromessenger") {
    return true;
  } else {
    return false;
  }
} // cordova


function isCordova() {
  return window.cordova;
}

function isAppcan() {
  return window.uexDispatcherNative;
}

var _default = function _default(_ref) {
  var children = _ref.children,
      control = _ref.control,
      projectCfg = _ref.projectCfg,
      _ref$mainThread = _ref.mainThread,
      mainThread = _ref$mainThread === void 0 ? false : _ref$mainThread,
      formTemplates = _ref.formTemplates;
  var wechat = projectCfg.wechat,
      cordova = projectCfg.cordova,
      baidumap = projectCfg.baidumap;

  var Provider = function Provider(_ref2) {
    var children = _ref2.children;

    if (baidumap) {
      return /*#__PURE__*/_react["default"].createElement(_BaiduMapProvider["default"], baidumap, /*#__PURE__*/_react["default"].createElement(_providers["default"].Browser, {
        checkUpdate: mainThread
      }, children));
    }

    return /*#__PURE__*/_react["default"].createElement(_providers["default"].Browser, null, children);
  };

  if (isWeixin() && wechat) {
    Provider = function Provider(_ref3) {
      var children = _ref3.children;

      if (baidumap) {
        return /*#__PURE__*/_react["default"].createElement(_BaiduMapProvider["default"], null, /*#__PURE__*/_react["default"].createElement(_providers["default"].Wechat, wechat, children));
      }

      return /*#__PURE__*/_react["default"].createElement(_providers["default"].Wechat, wechat, children);
    };
  }

  if (isCordova()) {
    var cordovaProps = cordova || {};

    Provider = function Provider(_ref4) {
      var children = _ref4.children;

      if (baidumap) {
        return /*#__PURE__*/_react["default"].createElement(_BaiduMapProvider["default"], baidumap, /*#__PURE__*/_react["default"].createElement(_providers["default"].Cordova, _extends({
          checkUpdate: mainThread
        }, cordovaProps), children));
      }

      return /*#__PURE__*/_react["default"].createElement(_providers["default"].Cordova, cordovaProps, children);
    };
  }

  if (isAppcan()) {
    Provider = function Provider(_ref5) {
      var children = _ref5.children;

      if (baidumap) {
        return /*#__PURE__*/_react["default"].createElement(_BaiduMapProvider["default"], baidumap, /*#__PURE__*/_react["default"].createElement(_providers["default"].Appcan, null, children));
      }

      return /*#__PURE__*/_react["default"].createElement(_providers["default"].Appcan, null, children);
    };
  }

  return /*#__PURE__*/_react["default"].createElement(_antdMobile.LocaleProvider, {
    locale: getAntLocale()
  }, /*#__PURE__*/_react["default"].createElement(_ApplicationProvider["default"], null, /*#__PURE__*/_react["default"].createElement(_TemplateProvider["default"], {
    CustomControls: control,
    formTemplates: formTemplates
  }, /*#__PURE__*/_react["default"].createElement(Provider, null, children))));
};

exports["default"] = _default;