"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.showModal = showModal;
exports.init = void 0;

var _react = _interopRequireWildcard(require("react"));

var _yes = require("yes");

var _reactNativeRootSiblings = _interopRequireDefault(require("react-native-root-siblings"));

var _yesCompReactNativeWeb = require("yes-comp-react-native-web");

var _yesWeb = require("yes-web");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _yesIntf = require("yes-intf");

var _AppWrapper = _interopRequireDefault(require("../AppWrapper"));

var _i18n = _interopRequireDefault(require("../i18n"));

var _global = _interopRequireDefault(require("global"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

// let modalHandler = null;
var siblingKey = 0;
var inited = false;
var control = null;
var ProjectCfg = null;
var billforms = [];

var init = function init(c, p, b) {
  control = c;
  ProjectCfg = p;
  billforms = b;
  inited = true;
};

exports.init = init;

var getLocaleMessages = function getLocaleMessages() {
  if (navigator.language.startsWith('zh')) {
    return _i18n["default"]['zh-CN'];
  }

  return _i18n["default"]['en-US'];
};

var modalStack = [];
_global["default"].modalStack = modalStack;

_yes.AppDispatcher.register(function (action) {
  switch (action.type) {
    case 'LOGOUTED':
      modalStack.forEach(function (item) {
        item();
      });
      break;
  }
});

var getMappedComponent = function getMappedComponent(tag) {
  return _yesCompReactNativeWeb.ControlMappings.defaultControlMapping.get(tag);
};

var DummyApp = /*#__PURE__*/function (_PureComponent) {
  _inherits(DummyApp, _PureComponent);

  var _super = _createSuper(DummyApp);

  function DummyApp() {
    _classCallCheck(this, DummyApp);

    return _super.apply(this, arguments);
  }

  _createClass(DummyApp, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        getMappedComponent: getMappedComponent
      };
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);

  return DummyApp;
}(_react.PureComponent);

DummyApp.childContextTypes = {
  getMappedComponent: _propTypes["default"].func
};

function createCallback(mh) {
  var fn = function fn() {
    if (mh) {
      mh.destroy();
      var index = modalStack.indexOf(fn);

      if (index < 0) {
        console.error("siblingmgr error!");
      } else {
        modalStack.splice(index, 1);
      }

      mh = null;
    }
  };

  modalStack.push(fn);
  return fn;
}

function showModal(children, fullScreen) {
  var closeModal = function closeModal() {
    backHandler();
    callback();
  };

  var modalHandler = new _reactNativeRootSiblings["default"]( /*#__PURE__*/_react["default"].createElement(_yesIntf.YIGOEnvProvider, {
    locale: getLocaleMessages(),
    controlMapping: _yesCompReactNativeWeb.ControlMappings.defaultControlMapping
  }, /*#__PURE__*/_react["default"].createElement(_AppWrapper["default"], {
    formTemplates: billforms,
    control: control,
    projectCfg: ProjectCfg
  }, _react["default"].cloneElement(children, {
    onClose: closeModal
  }))));

  _yesWeb.History.push("#Sibling_".concat(siblingKey++));

  var callback = createCallback(modalHandler);

  var backHandler = _yes.BackHandler.addPreEventListener(function () {
    backHandler();
    callback();
  });

  return function () {
    backHandler();
    callback();
  };
}