"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _yesWeb = require("yes-web");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FontAwesome = _interopRequireDefault(require("react-native-vector-icons/FontAwesome"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var styles = _reactNative.StyleSheet.create({
  header: {
    flexDirection: 'row',
    borderBottomWidth: 1,
    borderBottomColor: 'lightgrey'
  },
  headerLight: {
    backgroundColor: 'black'
  },
  headerDark: {
    backgroundColor: 'white'
  },
  absoluteTitle: {
    position: 'absolute',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0,
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center'
  },
  flexTitle: {
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'flex-start'
  },
  headerBack: {
    margin: 13,
    zIndex: 1
  },
  icon: {
    width: 24,
    textAlign: 'center'
  },
  lightMode: {
    color: 'white'
  },
  textStyle: {
    marginTop: 13,
    marginBottom: 13,
    marginLeft: 13,
    height: 24,
    display: 'flex',
    alignItems: 'center'
  },
  transparent: {
    backgroundColor: 'transparent'
  }
});

var Header = /*#__PURE__*/function (_PureComponent) {
  _inherits(Header, _PureComponent);

  var _super = _createSuper(Header);

  function Header() {
    var _this;

    _classCallCheck(this, Header);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.createLeftElement = function () {
      if (_this.props.leftElement) {
        return _this.props.leftElement;
      }

      if (_this.props.canBack) {
        return /*#__PURE__*/_react["default"].createElement(HeadBackButton, {
          iconStyle: _this.props.mode === 'light' ? styles.lightMode : null,
          onPress: _this.props.backHandler
        });
      }

      return null;
    };

    _this.createTitleElement = function () {
      if (_this.props.titleElement) {
        return _this.context.createElement(_this.props.titleElement, {
          mode: _this.props.mode
        });
      }

      if (_this.props.title) {
        return /*#__PURE__*/_react["default"].createElement(HeadTitle, {
          style: [_this.props.titleMode === 'flex' ? styles.flexTitle : styles.absoluteTitle, _this.props.titleStyle],
          title: _this.props.title,
          textStyle: [_this.props.mode === 'light' ? styles.lightMode : null, _this.props.textStyle]
        });
      }

      return null;
    };

    _this.createRightElement = function () {
      if (_this.props.rightElement) {
        return _this.context.createElement(_this.props.rightElement); // return this.props.rightElement;
      }

      return null;
    };

    _this.getPaddingStyle = function () {
      var topPadding = 0;

      if (_this.context.getTopPadding) {
        topPadding = _this.context.getTopPadding();
      }

      return {
        paddingTop: topPadding
      };
    };

    return _this;
  }

  _createClass(Header, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.header, this.getPaddingStyle(), this.props.mode === 'light' ? styles.headerLight : styles.headerDark, this.props.transparent ? styles.transparent : null, this.props.headerStyle]
      }, this.createLeftElement(), this.createTitleElement(), this.createRightElement());
    }
  }]);

  return Header;
}(_react.PureComponent);

Header.propTypes = {
  titleMode: _propTypes["default"].oneOf(['flex', 'absolute']),
  //flex=使用 flex布局，absolute=使用absolute布局
  mode: _propTypes["default"].oneOf(['dark', 'light']),
  title: _propTypes["default"].string,
  titleElement: _propTypes["default"].shape({
    type: _propTypes["default"].oneOf(['element']),
    elementType: _propTypes["default"].string,
    elementProps: _propTypes["default"].object
  })
};
Header.defaultProps = {
  titleMode: 'flex',
  //flex=使用 flex布局，absolute=使用absolute布局
  canBack: true,
  mode: 'dark',
  transparent: false
};
Header.contextTypes = {
  createElement: _propTypes["default"].func,
  getTopPadding: _propTypes["default"].func
};

var HeaderBackButton = /*#__PURE__*/function (_PureComponent2) {
  _inherits(HeaderBackButton, _PureComponent2);

  var _super2 = _createSuper(HeaderBackButton);

  function HeaderBackButton() {
    _classCallCheck(this, HeaderBackButton);

    return _super2.apply(this, arguments);
  }

  _createClass(HeaderBackButton, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          onPress = _this$props.onPress,
          style = _this$props.style,
          iconStyle = _this$props.iconStyle;
      return /*#__PURE__*/_react["default"].createElement(_reactNative.TouchableOpacity, {
        style: {
          zIndex: 1
        },
        onPress: onPress
      }, /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.headerBack, style]
      }, /*#__PURE__*/_react["default"].createElement(_FontAwesome["default"], {
        style: [styles.icon, iconStyle],
        size: 24,
        name: "angle-left"
      })));
    }
  }]);

  return HeaderBackButton;
}(_react.PureComponent); // @withNavigation


var HeadBackButton = /*#__PURE__*/function (_PureComponent3) {
  _inherits(HeadBackButton, _PureComponent3);

  var _super3 = _createSuper(HeadBackButton);

  function HeadBackButton() {
    var _this2;

    _classCallCheck(this, HeadBackButton);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _super3.call.apply(_super3, [this].concat(args));

    _this2.onPress = function () {
      // this.props.navigation.goBack(null);
      if (_this2.props.onPress) {
        _this2.props.onPress();

        return;
      }

      _yesWeb.History.goBack();
    };

    return _this2;
  }

  _createClass(HeadBackButton, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react["default"].createElement(HeaderBackButton, _extends({}, this.props, {
        onPress: this.onPress
      }));
    }
  }]);

  return HeadBackButton;
}(_react.PureComponent);

HeadBackButton.contextTypes = {
  getBillForm: _propTypes["default"].func
};

var HeadTitle = /*#__PURE__*/function (_PureComponent4) {
  _inherits(HeadTitle, _PureComponent4);

  var _super4 = _createSuper(HeadTitle);

  function HeadTitle() {
    _classCallCheck(this, HeadTitle);

    return _super4.apply(this, arguments);
  }

  _createClass(HeadTitle, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.title, this.props.style]
      }, /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
        style: [styles.textStyle, this.props.textStyle]
      }, this.props.title));
    }
  }]);

  return HeadTitle;
}(_react.PureComponent);

HeadTitle.defaultProps = {};
Object.assign(Header, {
  HeadBackButton: HeadBackButton,
  HeadTitle: HeadTitle
});
var _default = Header;
exports["default"] = _default;