"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

var _FontAwesome = _interopRequireDefault(require("react-native-vector-icons/FontAwesome"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var pressRetentionOffset = {
  top: 5,
  left: 5,
  right: 5,
  bottom: 5
};

var _default = function _default(props) {
  var renderLeftElement = function renderLeftElement() {
    return props.leftElement;
  };

  var renderCenterElement = function renderCenterElement() {
    return props.centerElement;
  };

  var renderRightElement = function renderRightElement() {
    return props.rightElement;
  };

  var renderArrow = function renderArrow() {
    return props.showArrow ? /*#__PURE__*/_react["default"].createElement(_FontAwesome["default"], {
      style: styles.arrow,
      name: "chevron-right"
    }) : null;
  };

  var renderExtra = function renderExtra() {
    return props.extra || null;
  };

  var onPress = function onPress() {
    props && props.onPress(props.rowIndex);
  };

  var renderDetail = function renderDetail() {
    return props.detailElement;
  };

  var containerView = props.containerView;
  var container = null;

  if (props.detailElement) {
    if (containerView) {
      container = _react["default"].cloneElement(containerView, {
        style: [styles.container, props.containerStyle]
      }, [renderLeftElement(), renderCenterElement(), renderRightElement(), renderArrow(), renderExtra()]);
    } else {
      container = /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.container, props.containerStyle]
      }, renderLeftElement(), renderCenterElement(), renderRightElement(), renderArrow(), renderExtra());
    }

    return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
      style: [props.divider ? [styles.divider, props.dividerStyle] : {}]
    }, /*#__PURE__*/_react["default"].createElement(_reactNative.TouchableOpacity, {
      onPress: onPress,
      pressRetentionOffset: pressRetentionOffset
    }, container), renderDetail());
  }

  if (containerView) {
    container = _react["default"].cloneElement(containerView, {
      style: [styles.container, props.divider ? [styles.divider, props.dividerStyle] : {}, props.containerStyle]
    }, [renderLeftElement(), renderCenterElement(), renderRightElement(), renderArrow(), renderExtra()]);
  } else {
    container = /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
      style: [styles.container, props.divider ? [styles.divider, props.dividerStyle] : {}, props.containerStyle]
    }, renderLeftElement(), renderCenterElement(), renderRightElement(), renderArrow(), renderExtra());
  }

  return /*#__PURE__*/_react["default"].createElement(_reactNative.TouchableOpacity, {
    onPress: onPress,
    pressRetentionOffset: pressRetentionOffset
  }, container);
};

exports["default"] = _default;

var styles = _reactNative.StyleSheet.create({
  container: {
    flexDirection: 'row',
    alignItems: 'stretch'
  },
  divider: {
    borderBottomWidth: 1,
    borderBottomColor: 'lightgray'
  },
  arrow: {
    alignItems: 'center',
    display: 'flex',
    color: 'rgba(0,0,0,0.6)'
  },
  centerStyle: {},
  primaryContainer: {},
  primaryText: {},
  secondaryContainer: {},
  secondaryText: {}
});