"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _yesIntf = require("yes-intf");

var _reactNative = require("react-native");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _yesCompReactNativeWeb = require("yes-comp-react-native-web");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var styles = _reactNative.StyleSheet.create({
  weekrow: {
    flexDirection: 'row',
    flexBasis: 'auto',
    borderBottomWidth: 1,
    borderBottomColor: 'lightgray'
  },
  container: {
    flexDirection: 'column',
    flexBasis: 'auto'
  },
  weekday: {
    flex: 1,
    justifyContent: 'center',
    display: 'flex',
    alignItems: 'center'
  }
});

var Calendar = /*#__PURE__*/function (_PureComponent) {
  _inherits(Calendar, _PureComponent);

  var _super = _createSuper(Calendar);

  function Calendar() {
    var _this;

    _classCallCheck(this, Calendar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.genMonthData = function (year, month) {
      var dayCount = _this.getCountDays(year, month);

      var data = [];
      var week = [];

      for (var i = 0; i < dayCount; i++) {
        var date = new Date(year, month, i + 1);

        if (date.getDay() === 0) {
          if (week.length > 0) {
            data.push(week);
          }

          week = [];
        }

        week.push({
          date: date,
          week: date.getDay(),
          day: date.getDate()
        });
      }

      if (week.length > 0) {
        data.push(week);
      }

      return data;
    };

    _this.state = {
      data: _this.genMonthData(_this.props.year, _this.props.month),
      events: _this.props.events
    };

    _this.renderDay = function (day) {
      if (_this.props.renderDay) {
        return _this.props.renderDay(day, _this.props.onSelect);
      }

      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.weekday]
      }, /*#__PURE__*/_react["default"].createElement(_reactNative.Text, null, day ? day.day : ''));
    };

    _this.renderWeekCaption = function () {
      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.weekrow, _this.props.captionRowStyle]
      }, /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
        style: [styles.weekday]
      }, _this.props.format("Sun")), /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
        style: [styles.weekday]
      }, _this.props.format("Mon")), /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
        style: [styles.weekday]
      }, _this.props.format("Tue")), /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
        style: [styles.weekday]
      }, _this.props.format("Web")), /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
        style: [styles.weekday]
      }, _this.props.format("Tur")), /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
        style: [styles.weekday]
      }, _this.props.format("Fir")), /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
        style: [styles.weekday]
      }, _this.props.format("Sat")));
    };

    _this.renderWeekDays = function (week) {
      var weeks = [0, 1, 2, 3, 4, 5, 6];
      var weekDays = week.map(function (d) {
        return d.week;
      });
      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.weekrow, _this.props.weekRowStyle]
      }, weeks.map(function (day) {
        if (weekDays.includes(day)) {
          return _this.renderDay(week[weekDays.indexOf(day)]);
        }

        return _this.renderDay(null);
      }));
    };

    _this.renderWeekView = function () {
      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.container]
      }, _this.state.data.map(function (week) {
        return _this.renderWeekDays(week);
      }));
    };

    return _this;
  }

  _createClass(Calendar, [{
    key: "getCountDays",
    value: function getCountDays(year, month) {
      var curDate = new Date(year, month, 1);
      var curMonth = curDate.getMonth();
      curDate.setMonth(curMonth + 1);
      curDate.setDate(0);
      return curDate.getDate();
    }
    /**
     * 产生月份数据
     */

  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        data: this.genMonthData(nextProps.year, nextProps.month)
      });
    }
  }, {
    key: "render",
    value: function render() {
      // const { events, year, month } = this.props;
      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.container]
      }, this.renderWeekCaption(), this.renderWeekView());
    }
  }]);

  return Calendar;
}(_react.PureComponent);

var CalenarDay = /*#__PURE__*/function (_Component) {
  _inherits(CalenarDay, _Component);

  var _super2 = _createSuper(CalenarDay);

  function CalenarDay() {
    _classCallCheck(this, CalenarDay);

    return _super2.apply(this, arguments);
  }

  _createClass(CalenarDay, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      var nextData = nextProps.events;
      var data = this.props.events;

      if (this.props.day != nextProps.day) {
        return false;
      }

      if (!data && !nextData) {
        return true;
      }

      if (!data || !nextData) {
        return true;
      }

      if (data.length !== nextData.length) {
        return false;
      }

      for (var i = 0; i < data.length; i++) {
        if (data[i] !== nextData[i]) {
          return false;
          j;
        }
      }

      return true;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          day = _this$props.day,
          events = _this$props.events;
      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.weekday]
      }, /*#__PURE__*/_react["default"].createElement(_reactNative.Text, null, day ? day.day : ''));
    }
  }]);

  return CalenarDay;
}(_react.Component);

var CalendarGrid = /*#__PURE__*/function (_PureComponent2) {
  _inherits(CalendarGrid, _PureComponent2);

  var _super3 = _createSuper(CalendarGrid);

  function CalendarGrid() {
    var _this2;

    _classCallCheck(this, CalendarGrid);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _super3.call.apply(_super3, [this].concat(args));

    _this2.genDayEvents = function (props) {
      if (props.data) {
        var owner = _this2.context.getOwner();

        var data = {};
        props.data.reduce(function (total, v, index) {
          var dt = owner.getValueByKey(index, props.dateField);
          var dtKey = dt.toDateString();

          if (!data[dtKey]) {
            data[dtKey] = [];
          }

          var dtEvents = data[dtKey];
          dtEvents.push({
            rowIndex: index,
            data: v
          });
        }, data);
        return data;
      }

      return null;
    };

    _this2.state = {
      data: _this2.genDayEvents(_this2.props)
    };

    _this2.renderDay = function (day, onSelect) {
      // const owner = this.context.getOwner();
      // const Day = this.prop.DayComp || CalendarDay;
      if (day && _this2.state.data) {
        // const date = owner.getValueByKey(0, this.props.dateField);
        var dtKey = day.date.toDateString();
        var events = _this2.state.data[dtKey];
        return _this2.props.DayElement ? _react["default"].cloneElement(_this2.props.DayElement, {
          events: events,
          day: day,
          onSelect: onSelect,
          selected: day === _this2.state.day
        }) : /*#__PURE__*/_react["default"].createElement(CalenarDay, {
          key: day.day,
          events: events,
          day: day,
          onSelect: onSelect
        });
      }

      return _this2.props.DayElement ? _react["default"].cloneElement(_this2.props.DayElement, {
        day: day
      }) : /*#__PURE__*/_react["default"].createElement(CalenarDay, {
        day: day
      });
    };

    _this2.getDate = function (row) {
      var owner = _this2.context.getOwner();

      var date = owner.getValueByKey(row, _this2.props.dateField);
      return date;
    };

    _this2.onSelect = function (day, events) {
      _this2.setState({
        day: day,
        events: events
      });
    };

    _this2.renderRow = function (rowIndex) {
      return _this2.props.rowElement ? _react["default"].cloneElement(_this2.props.rowElement, {
        rowIndex: rowIndex,
        gridId: _this2.props.yigoid,
        onClick: _this2.props.onClick
      }) : null;
    };

    _this2.addNewRow = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var defaultValue;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              defaultValue = {};
              defaultValue[_this2.props.dateField] = _this2.state.day.date;
              _context.next = 4;
              return _this2.props.addNewRow(defaultValue);

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return _this2;
  }

  _createClass(CalendarGrid, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var newState = {
        data: this.genDayEvents(nextProps)
      };

      if (this.state.day) {
        newState.events = newState.data[this.state.day.date.toDateString()];
      }

      this.setState(newState);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props2 = this.props,
          data = _this$props2.data,
          dateField = _this$props2.dateField,
          controlState = _this$props2.controlState,
          disabled = _this$props2.disabled,
          titleElement = _this$props2.titleElement;
      var editable = controlState.get('editable') && !disabled;
      var year = null,
          month = null;

      if (data && data.size > 0) {
        var owner = this.context.getOwner();
        var date = owner.getValueByKey(0, this.props.dateField);
        year = date.getFullYear();
        month = date.getMonth();
      }

      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, null, /*#__PURE__*/_react["default"].createElement(_reactNative.View, null, /*#__PURE__*/_react["default"].createElement(_reactNative.Text, null, "".concat(year, "-").concat(month))), /*#__PURE__*/_react["default"].createElement(Calendar, _extends({
        format: this.props.formatMessage,
        dateField: dateField,
        year: year,
        renderDay: this.renderDay,
        month: month,
        getDate: this.getDate,
        events: data,
        onSelect: this.onSelect
      }, this.props)), /*#__PURE__*/_react["default"].createElement(_reactNative.View, null, this.state.events ? this.state.events.map(function (event) {
        return _this3.renderRow(event.rowIndex);
      }) : null, editable ? /*#__PURE__*/_react["default"].createElement(_reactNative.Button, {
        onPress: this.addNewRow
      }) : null));
    }
  }]);

  return CalendarGrid;
}(_react.PureComponent);

CalendarGrid.contextTypes = {
  getOwner: _propTypes["default"].func
};

var _default = (0, _yesIntf.GridWrap)((0, _yesCompReactNativeWeb.withDetail)((0, _yesIntf.internationalWrap)(CalendarGrid))); // export default Calendar;


exports["default"] = _default;