"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

var _FontAwesome = _interopRequireDefault(require("react-native-vector-icons/FontAwesome"));

var _Element = _interopRequireDefault(require("../../template/Element"));

var _FormContextWrap = _interopRequireDefault(require("../Context/FormContextWrap"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var styles = _reactNative.StyleSheet.create({
  container: {
    justifyContent: 'center'
  },
  directionRow: {
    flexDirection: 'row'
  },
  directionColumn: {
    flexDirection: 'column'
  },
  textStyle: {
    color: '#008cd7'
  }
});

var _default = (0, _FormContextWrap["default"])(function (props) {
  var onPress = function onPress() {
    props.onChange(!props.value);
  };

  var icon = props.icon,
      title = props.title,
      style = props.style,
      textStyle = props.textStyle,
      iconStyle = props.iconStyle,
      direction = props.direction,
      value = props.value;
  var iconElement = null;
  var iconSt = iconStyle;

  if (typeof iconStyle === 'function') {
    iconSt = iconStyle(value);
  }

  if (icon) {
    if (typeof icon === 'string') {
      iconElement = /*#__PURE__*/_react["default"].createElement(_FontAwesome["default"], {
        name: icon,
        style: iconSt
      });
    } else {
      iconElement = /*#__PURE__*/_react["default"].createElement(_Element["default"], {
        meta: icon
      });
    }
  }

  var titleElement = null;
  var titleStyle = textStyle;

  if (typeof textStyle === 'function') {
    titleStyle = textStyle(value);
  }

  if (title) {
    if (typeof title === 'string') {
      titleElement = /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
        style: [styles.textStyle, titleStyle]
      }, title);
    } else {
      titleElement = /*#__PURE__*/_react["default"].createElement(_Element["default"], {
        meta: title
      });
    }
  }

  return /*#__PURE__*/_react["default"].createElement(_reactNative.TouchableHighlight, {
    onPress: onPress,
    style: [{
      flex: 1
    }, styles.container, style]
  }, /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
    style: [direction === 'row' ? styles.directionRow : styles.directionColumn]
  }, iconElement, titleElement));
});

exports["default"] = _default;