"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _navigateUtil = require("../../util/navigateUtil");

var _antdMobile = require("antd-mobile");

var _yesIntf = require("yes-intf");

var _yesWeb = require("yes-web");

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var OpenFormClick = /*#__PURE__*/function (_PureComponent) {
  _inherits(OpenFormClick, _PureComponent);

  var _super = _createSuper(OpenFormClick);

  function OpenFormClick() {
    var _this;

    _classCallCheck(this, OpenFormClick);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.openForm = function () {
      _this._openForm(_this.props);
    };

    _this._openForm = function (item) {
      var formKey = item.formKey,
          oid = item.oid,
          status = item.status,
          modal = item.modal;

      if (modal) {
        (0, _navigateUtil.openModal)(formKey, oid, status);
        return;
      }

      (0, _navigateUtil.openForm)(formKey, oid, status);
    };

    _this.onPress = function () {
      var multiple = _this.props.multiple;

      if (!multiple) {
        _this.openForm();

        return;
      }

      _this.onActionClick();
    };

    _this.onButtonClick = function (index) {
      var items = _this.props.items;
      var item = items[index];

      _this.backHandler();

      if (item) {
        _this._openForm(item);
      }
    };

    _this.onActionClick = function () {
      var items = _this.props.items;
      var itms = items.map(function (item) {
        return item.text;
      });
      itms.push('取消');

      _antdMobile.ActionSheet.showActionSheetWithOptions({
        options: itms,
        cancelButtonIndex: itms.length - 1,
        message: null,
        maskClosable: true
      }, _this.onButtonClick);

      _yesWeb.History.push("#ActionSheet", false);

      _this.backHandler = _yesIntf.BackHandler.addPreEventListener(function () {
        _antdMobile.ActionSheet.close();

        _this.backHandler();

        return false;
      });
      return;
    };

    return _this;
  }

  _createClass(OpenFormClick, [{
    key: "render",
    value: function render() {
      // const { style, multiple } = this.props;
      // if (!multiple) {
      //     return (
      //         <ActionButton onPress={this.openForm} style={style} />
      //     )
      // }
      // return (
      //     <ActionButton onPress={this.onActionClick} style={style} />
      // )
      var _this$props = this.props,
          element = _this$props.element,
          children = _this$props.children;
      var child = this.context.createElement(element || children);
      return _react["default"].cloneElement(child, {
        onPress: this.onPress
      });
    }
  }]);

  return OpenFormClick;
}(_react.PureComponent);

exports["default"] = OpenFormClick;
OpenFormClick.contextTypes = {
  createElement: _propTypes["default"].func
};
OpenFormClick.defaultProps = {
  status: 'EDIT',
  modal: false,
  multiple: false
};