"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _yesIntf = require("yes-intf");

var _reactNative = require("react-native");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactWxImagesViewer = _interopRequireDefault(require("react-wx-images-viewer"));

var _yesCore = require("yes-core");

var _Element = _interopRequireDefault(require("../../../template/Element"));

var _yesWeb = require("yes-web");

var _FontAwesome = _interopRequireDefault(require("react-native-vector-icons/FontAwesome"));

var _class, _class2, _temp, _class3, _class4, _temp2;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var mineTypes = [{
  ext: 'doc',
  minetype: 'application/msword'
}, {
  ext: 'docx',
  minetype: 'application/msword'
}, {
  ext: 'pdf',
  minetype: 'application/pdf'
}, {
  ext: 'ppt',
  minetype: 'application/vnd.ms-powerpoint'
}, {
  ext: 'xls',
  minetype: 'application/vnd.ms-excel'
}, {
  ext: 'xlsx',
  minetype: 'application/vnd.ms-excel'
}, {
  ext: 'rtf',
  minetype: 'application/rtf'
}, {
  ext: 'txt',
  minetype: 'text/plain'
}, {
  ext: 'png',
  minetype: 'image/png'
}, {
  ext: 'jpg',
  minetype: 'image/jpeg'
}, {
  ext: 'jpeg',
  minetype: 'image/jpeg'
}, {
  ext: 'apk',
  minetype: 'application/vnd.android.package-archive'
}];

var getMineType = function getMineType(file) {
  if (!file) return null;
  var minetype = mineTypes.find(function (item) {
    return file.endsWith(item.ext);
  });
  return minetype ? minetype.minetype : '*/*';
};

var getFileName = function getFileName(_url) {
  var txt = _url.split('/').pop();

  var timestamp = Date.parse(new Date());
  var newname = timestamp + '.' + txt.split('.').slice(-1).toString();
  return newname;
};

function isChineseChar(str) {
  var reg = /[\u4E00-\u9FA5\uF900-\uFA2D]/;
  return reg.test(str);
}

var downloadFile = function downloadFile(_url, fileName) {
  return new Promise(function (resolve, reject) {
    // const fileName = getFileName(_url);
    var onFileSystemSuccess = function onFileSystemSuccess(fileSystem) {
      var fs = null;

      if (cordova.platformId === "android") {
        fs = fileSystem;
      } else {
        fs = fileSystem.root;
      }

      fs.getFile(fileName, {
        create: true,
        exclusive: false
      }, function gotFileEntry(fileEntry) {
        fileEntry.remove();
        var ft = new FileTransfer();
        var uri = _url;

        if (isChineseChar(_url)) {
          uri = encodeURI(_url);
        }

        ft.download(uri, fileEntry.nativeURL, function (entry) {
          var minetype = getMineType(fileName);
          resolve();
          cordova.plugins.fileOpener2.open(entry.toURL(), minetype);
        }, function (error) {
          reject(error.getMessage());
        }, false);
      }, function (error) {
        return reject(error.getMessage());
      });
    };

    var onError = function onError(error) {
      reject(error);
    };

    if (!cordova) {
      reject("".concat(fileName, " has not been supported!"));
    }

    if (cordova.platformId === "android") {
      window.resolveLocalFileSystemURL(cordova.file.externalRootDirectory, onFileSystemSuccess, onError);
    } else {
      window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onFileSystemSuccess, onError);
    }
  });
};

var styles = _reactNative.StyleSheet.create({
  image: {
    flex: 1
  },
  container: {
    flexDirection: 'row',
    flexWrap: 'wrap',
    paddingLeft: 12
  },
  title: {
    paddingLeft: 16,
    paddingTop: 8,
    paddingBottom: 8,
    height: 35
  },
  noattach: {
    backgroundColor: 'white',
    height: 40,
    padding: 16,
    alignItems: 'center',
    justifyContent: 'center',
    display: 'flex'
  },
  item: {
    width: '33%',
    paddingRight: 12,
    paddingBottom: 12,
    height: 100
  },
  icon: {
    position: 'absolute',
    right: 20,
    top: 10
  },
  fileTypeContainer: {
    flex: 1,
    justifyContent: 'center',
    alignItems: 'center'
  },
  fileTypeIcon: {
    fontSize: 40
  }
});

var AttachmentFile = (0, _yesIntf.ControlWrap)(_class = (_temp = _class2 = /*#__PURE__*/function (_PureComponent) {
  _inherits(AttachmentFile, _PureComponent);

  var _super = _createSuper(AttachmentFile);

  function AttachmentFile() {
    var _this;

    _classCallCheck(this, AttachmentFile);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _this.buildThumbnail = function (url) {
      if (_yesIntf.Util.buildThumbnailUrl) {
        return _yesIntf.Util.buildThumbnailUrl(url, 100, 100);
      }

      return url;
    };

    _this.isImage = function () {
      var fileType = _this.props.fileType;
      var tmp = fileType ? fileType.toLowerCase() : "";
      return tmp === 'jpg' || tmp === 'png' || tmp === 'jpeg';
    };

    _this.getFileTypeIcon = function (type) {
      var result = 'file';

      switch (type) {
        case 'pdf':
          result = "file-pdf-o";
          break;

        case 'xls':
        case 'xlsx':
          result = 'file-excel-o';
          break;

        case 'doc':
        case 'docx':
          result = 'file-word-o';
          break;

        case 'ppt':
          result = 'file-powerpoint-o';
          break;
      }

      return result;
    };

    _this.openFile = function () {
      var _this$props = _this.props,
          displayValue = _this$props.displayValue,
          yigoAttachment = _this$props.yigoAttachment;

      var billform = _this.context.getBillForm();

      var formKey = billform.form.formKey;
      var file = yigoAttachment ? "".concat(_yesCore.Svr.SvrMgr.AttachURL, "?path=").concat(displayValue, "&formKey=").concat(formKey, "&service=DownloadAttachment&mode=2") : displayValue;

      _yesIntf.Util.safeExec( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return downloadFile(file, getFileName(displayValue));

              case 2:
                return _context.abrupt("return", _context.sent);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      })));
    };

    return _this;
  }

  _createClass(AttachmentFile, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          displayValue = _this$props2.displayValue,
          fileType = _this$props2.fileType,
          style = _this$props2.style,
          yigoAttachment = _this$props2.yigoAttachment;

      if (this.isImage()) {
        if (yigoAttachment) {
          var billform = this.context.getBillForm();
          var formKey = billform.form.formKey;
          var url = this.buildThumbnail("".concat(_yesCore.Svr.SvrMgr.AttachURL, "?path=").concat(displayValue, "&formKey=").concat(formKey, "&service=DownloadImage&mode=2"));
          return /*#__PURE__*/_react["default"].createElement(_reactNative.Image, {
            source: url,
            style: [styles.image, style]
          });
        } else {
          return /*#__PURE__*/_react["default"].createElement(_reactNative.Image, {
            source: displayValue,
            style: [styles.image, style]
          });
        }
      }

      return /*#__PURE__*/_react["default"].createElement(_reactNative.TouchableHighlight, {
        onPress: this.openFile,
        style: styles.fileTypeContainer
      }, /*#__PURE__*/_react["default"].createElement(_FontAwesome["default"], {
        style: styles.fileTypeIcon,
        name: this.getFileTypeIcon(fileType)
      }));
    }
  }]);

  return AttachmentFile;
}(_react.PureComponent), _class2.contextTypes = {
  getBillForm: _propTypes["default"].func
}, _temp)) || _class;

var AttachmentItem = (0, _yesIntf.GridRowWrap)(_class3 = (_temp2 = _class4 = /*#__PURE__*/function (_PureComponent2) {
  _inherits(AttachmentItem, _PureComponent2);

  var _super2 = _createSuper(AttachmentItem);

  function AttachmentItem() {
    var _this2;

    _classCallCheck(this, AttachmentItem);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _super2.call.apply(_super2, [this].concat(args));

    _this2.onRemove = function () {
      _this2.props.remove && _this2.props.remove();
    };

    _this2.onPress = function () {
      _this2.props.onPress && _this2.props.onPress(_this2.props.rowIndex);
    };

    return _this2;
  }

  _createClass(AttachmentItem, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          removable = _this$props3.removable,
          fileUrl = _this$props3.fileUrl,
          fileType = _this$props3.fileType,
          style = _this$props3.style,
          yigoAttachment = _this$props3.yigoAttachment;
      return /*#__PURE__*/_react["default"].createElement(_reactNative.TouchableWithoutFeedback, {
        onPress: this.onPress
      }, /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.item, style]
      }, /*#__PURE__*/_react["default"].createElement(AttachmentFile, {
        yigoAttachment: yigoAttachment,
        fileType: fileType,
        yigoid: fileUrl
      }), removable ? /*#__PURE__*/_react["default"].createElement(_reactNative.TouchableWithoutFeedback, {
        onPress: this.onRemove
      }, /*#__PURE__*/_react["default"].createElement(_FontAwesome["default"], {
        name: "times",
        size: 20,
        style: styles.icon
      })) : null));
    }
  }]);

  return AttachmentItem;
}(_react.PureComponent), _class4.defaultProps = {
  removable: false,
  fileType: null,
  url: null,
  yigoAttachment: true
}, _temp2)) || _class3;

var AttachmentList = /*#__PURE__*/function (_PureComponent3) {
  _inherits(AttachmentList, _PureComponent3);

  var _super3 = _createSuper(AttachmentList);

  function AttachmentList() {
    var _this3;

    _classCallCheck(this, AttachmentList);

    for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    _this3 = _super3.call.apply(_super3, [this].concat(args));
    _this3.state = {
      showPreview: false
    };

    _this3.onViewerClose = function () {
      if (_this3.props.inline) {
        _this3.props.onRequestClose && _this3.props.onRequestClose();
        return;
      }

      _this3.setState({
        showPreview: false
      });

      _this3.backHandler && _this3.backHandler();
    };

    _this3.onViewerOpen = function (index) {
      _this3.setState({
        showPreview: true,
        index: index
      });

      _yesWeb.History.push("#AttachmentList_modal");

      _this3.backHandler = _yesIntf.BackHandler.addPreEventListener(function () {
        // this.backHandler();
        _this3.onViewerClose();
      });
    };

    return _this3;
  }

  _createClass(AttachmentList, [{
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props4 = this.props,
          data = _this$props4.data,
          fileName = _this$props4.fileName,
          filePath = _this$props4.filePath,
          isVirtual = _this$props4.isVirtual,
          title = _this$props4.title,
          multiSelect = _this$props4.multiSelect,
          containerStyle = _this$props4.containerStyle,
          removable = _this$props4.removable,
          editable = _this$props4.editable,
          inline = _this$props4.inline,
          yigoAttachment = _this$props4.yigoAttachment;
      var grid = this.context.getOwner();

      if (!grid) {
        return null;
      }

      var actionMeta = {
        type: 'element',
        elementType: 'AttachmentAction',
        elementProps: {
          style: {
            width: 85,
            display: 'inline-block'
          },
          multiSelect: multiSelect
        }
      };
      var billform = this.context.getBillForm();
      var formKey = billform.form.formKey; // const filePathIndex = grid.getCellIndexByKey(filePath);
      // const fileNameIndex = grid.getCellIndexByKey(fileName);

      var files = [];
      data.forEach(function (item, index) {
        var path = grid.getValueByKey(index, filePath);

        if (yigoAttachment) {
          // const path = item.getIn(['data', filePathIndex, 0]);
          files.push("".concat(_yesCore.Svr.SvrMgr.AttachURL, "?path=").concat(path, "&formKey=").concat(formKey, "&service=DownloadImage&mode=2"));
        } else {
          files.push(path);
        }
      });

      if (inline) {
        if (files.length > 0) {
          return /*#__PURE__*/_react["default"].createElement(_reactWxImagesViewer["default"], {
            onClose: this.onViewerClose,
            zIndex: 1000,
            urls: files,
            index: 0
          });
        }

        return /*#__PURE__*/_react["default"].createElement(_reactNative.TouchableWithoutFeedback, {
          onPress: this.onViewerClose
        }, /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
          style: {
            flex: 1,
            justifyContent: 'center',
            alignItems: 'center'
          }
        }, /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
          style: styles.noattach
        }, billform.form.formLoaded ? '没有附件,点击关闭' : '数据加载中...')));
      }

      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: this.props.style
      }, title ? /*#__PURE__*/_react["default"].createElement(_reactNative.View, null, /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
        style: [styles.title]
      }, title)) : null, /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.container, containerStyle]
      }, data.map(function (item, index) {
        // const fn = item.getIn(['data', fileNameIndex, 0]);
        var fn = grid.getValueByKey(index, fileName);
        var fnArray = fn.split('.');
        var fileType = fnArray.length > 1 ? fnArray[fnArray.length - 1] : null;
        return /*#__PURE__*/_react["default"].createElement(AttachmentItem, {
          yigoAttachment: yigoAttachment,
          rowIndex: index,
          removable: removable && editable,
          fileType: fileType,
          fileUrl: filePath,
          onPress: _this4.onViewerOpen
        });
      }), this.state.showPreview ? /*#__PURE__*/_react["default"].createElement(_reactWxImagesViewer["default"], {
        onClose: this.onViewerClose,
        zIndex: 1000,
        crossorigin: "use-credentials",
        urls: files,
        index: this.state.index
      }) : null, editable ? /*#__PURE__*/_react["default"].createElement(_Element["default"], {
        meta: actionMeta
      }) : null));
    }
  }]);

  return AttachmentList;
}(_react.PureComponent);

AttachmentList.contextTypes = {
  getOwner: _propTypes["default"].func,
  getBillForm: _propTypes["default"].func
};
AttachmentList.defaultProps = {
  removable: true,
  yigoAttachment: true,
  multiSelect: true
};

var _default = (0, _yesIntf.GridWrap)(AttachmentList);

exports["default"] = _default;