"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

var _yesIntf = require("yes-intf");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * 用于表格中的文本控件
 */
var SplitText = function SplitText(_ref) {
  var displayValue = _ref.displayValue,
      style = _ref.style,
      isVirtual = _ref.isVirtual,
      controlState = _ref.controlState,
      caption = _ref.caption,
      _ref$showIndex = _ref.showIndex,
      showIndex = _ref$showIndex === void 0 ? 0 : _ref$showIndex,
      _ref$splitStr = _ref.splitStr,
      splitStr = _ref$splitStr === void 0 ? " " : _ref$splitStr,
      _ref$emptyStr = _ref.emptyStr,
      emptyStr = _ref$emptyStr === void 0 ? "空" : _ref$emptyStr,
      format = _ref.format;
  var showStr = "";

  if (displayValue) {
    var splitArray = displayValue.split(splitStr);

    if (showIndex >= splitArray.length) {
      showStr = splitArray[0];
    } else {
      showStr = splitArray[showIndex];
    }
  }

  var formatResult = function formatResult(str) {
    if (format && typeof format === 'function') {
      return format(str);
    }

    return str;
  };

  return /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
    style: style
  }, formatResult(showStr || emptyStr));
};

var result = (0, _yesIntf.ControlWrap)(SplitText);
var _default = result;
exports["default"] = _default;