"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

require("./template");

var _yes = require("yes");

var _yesCompReactNativeWeb = require("yes-comp-react-native-web");

var _yesWeb = require("yes-web");

var _i18n = _interopRequireDefault(require("./i18n"));

var _yesCore = require("yes-core");

var _antdMobile = require("antd-mobile");

var _SiblingMgr = require("./SiblingMgr");

var _Element = _interopRequireDefault(require("./template/Element"));

var _webutil = require("yes-web/dist/webutil");

var _FontAwesome = _interopRequireDefault(require("react-native-vector-icons/Fonts/FontAwesome.ttf"));

var _fastclick = _interopRequireDefault(require("fastclick"));

var _TemplateView = _interopRequireDefault(require("./TemplateView"));

var _AppWrapper = _interopRequireDefault(require("./AppWrapper"));

var _navigateUtil = require("./util/navigateUtil");

var _Switch = _interopRequireDefault(require("./controls/Yigo/Checkbox/Switch"));

var _MonthPicker = _interopRequireDefault(require("./controls/Yigo/MonthPicker/MonthPicker"));

var _generateRouteComponent = _interopRequireDefault(require("./util/generateRouteComponent"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// import { ProjectCfg, RouteCfg, LoginCfg, ModalCfg, OpenwithHandler, billforms } from './config/index';
// import control from './config/control.js';
// import { util as projectUtil } from './project';
// import './preload';
var _default = function _default(dom, formInfo, ProjectCfg, LoginCfg, control) {
  var billforms = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};

  // const projectUtil = util;
  if (ProjectCfg.isYIGO3) {
    require('./yigopatch/yigo3');
  }

  if (ProjectCfg.fetch) {
    (0, _yesCore.injectFetchConfig)(ProjectCfg.fetch);
  }

  window.his = _yesWeb.History;
  window.Util = _yesWeb.Util;

  try {
    _yesWeb.IndexedDBCacheAdapter.clear('form');

    _yesWeb.IndexedDBCacheAdapter.clear('formdata');

    _yesWeb.IndexedDBCacheAdapter.clear('formrights');
  } catch (ignore) {}

  (0, _SiblingMgr.init)(control, ProjectCfg, billforms); // import './util/fakeFetch';
  // Reflect = undefined;

  _fastclick["default"].attach(document.body);

  (0, _webutil.injectFont)(_FontAwesome["default"], 'FontAwesome'); // projectUtil.showModal = showModal;

  var sessionKey = ProjectCfg.sessionKey,
      serverPath = ProjectCfg.serverPath,
      appName = ProjectCfg.appName,
      wechat = ProjectCfg.wechat,
      cordova = ProjectCfg.cordova,
      baidumap = ProjectCfg.baidumap;
  var template = LoginCfg.template,
      tooltip = LoginCfg.tooltip,
      companyName = LoginCfg.companyName,
      bgImagePath = LoginCfg.bgImagePath,
      logoImagePath = LoginCfg.logoImagePath;

  _yesCompReactNativeWeb.ControlMappings.defaultControlMapping.reg('checkbox', _Switch["default"]);

  _yesCompReactNativeWeb.ControlMappings.defaultControlMapping.reg('monthpicker', _MonthPicker["default"]); // let rootEl = null;
  // try {
  //     if (document) {
  //         rootEl = document.getElementById('app');
  //     }
  // } catch (e) {
  //     console.info(e.message);    // eslint-disable-line no-console
  // }


  var appOptions = {
    sessionKey: sessionKey,
    serverPath: serverPath,
    appName: appName,
    rootEl: dom,
    loginConfig: {
      template: control[template],
      tooltip: tooltip,
      companyName: companyName
    }
  };

  var getLocaleMessages = function getLocaleMessages() {
    if (navigator.language.startsWith('zh')) {
      return _i18n["default"]['zh-CN'];
    }

    return _i18n["default"]['en-US'];
  };

  var internationDictionary = getLocaleMessages();

  function formatMessage(msg) {
    return internationDictionary[msg] || msg;
  }

  _yesWeb.Util.alert = function (title, msg) {
    _yesWeb.History.push("#util_alert");

    var backHandler = _yes.BackHandler.addPreEventListener(function () {
      focusElement && focusElement.focus();
      modal.close();
      backHandler();
    });

    var focusElement = document.activeElement;
    document.body.focus();

    var modal = _antdMobile.Modal.alert(formatMessage(title), formatMessage(msg), [{
      text: formatMessage('OK'),
      onPress: function onPress() {
        focusElement && focusElement.focus();
        modal.close();
        backHandler();
      }
    }]);
  };

  _yesWeb.Util.showBillformInModal = function (formKey) {
    var oid = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : -1;
    var status = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'EDIT';
    var params = arguments.length > 3 ? arguments[3] : undefined;
    var showType = arguments.length > 4 ? arguments[4] : undefined;
    var modalKey = formKey;

    if (showType) {
      modalKey = "".concat(formKey, "_").concat(showType);
    }

    if (ModalCfg && ModalCfg.includes(modalKey)) {
      (0, _SiblingMgr.showModal)( /*#__PURE__*/_react["default"].createElement(_TemplateView["default"], {
        formKey: formKey,
        oid: oid,
        status: status,
        modalWrap: true,
        showType: showType || "modal",
        params: params
      }));
      return;
    }

    (0, _navigateUtil.openForm)(formKey, oid, status);
  };

  _yesWeb.Util.confirm = function (title, msg, type) {
    return new Promise(function (resolve, reject) {
      function pressOK() {
        resolve('OK');
      }

      function pressYes() {
        resolve('YES');
      }

      function pressNo() {
        resolve('NO');
      }

      function pressCancel() {
        resolve('Cancel');
      }

      var actions = [];

      if (type === 'OK') {
        actions.push({
          text: formatMessage('是'),
          onPress: pressOK
        });
      }

      if (type === 'YES_NO') {
        actions.push({
          text: formatMessage('否'),
          onPress: pressNo
        });
        actions.push({
          text: formatMessage('是'),
          onPress: pressYes
        });
      }

      if (type === 'YES_NO_CANCEL') {
        actions.push({
          text: formatMessage('是'),
          onPress: pressYes
        });
        actions.push({
          text: formatMessage('否'),
          onPress: pressNo
        });
        actions.push({
          text: formatMessage('取消'),
          onPress: pressCancel
        });
      }

      var newmsg = msg.replace(/\\n/g, '\n');

      _antdMobile.Modal.alert(formatMessage(title), newmsg, actions);
    });
  };

  _yesWeb.Util.buildThumbnailUrl = function (url, w, h) {
    var q = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1;
    return "".concat(url, "&w=").concat(w, "&h=").concat(h, "&q=").concat(q);
  };

  _yes.AppDispatcher.register(function (action) {
    switch (action.type) {
      case 'LOGOUTED':
        // history.go(0);
        console.log('logouted');
        break;
    }
  });

  var EmbedComp = (0, _generateRouteComponent["default"])(formInfo, {});
  var AuthRouter = (0, _yesCompReactNativeWeb.AuthenticatedRoute)(EmbedComp, function () {
    return /*#__PURE__*/_react["default"].createElement(_Element["default"], {
      meta: LoginCfg
    });
  }, 'root');

  var NavigatorListenerWrapper = function NavigatorListenerWrapper(props) {
    return /*#__PURE__*/_react["default"].createElement(_AppWrapper["default"], {
      formTemplates: billforms,
      projectCfg: ProjectCfg,
      control: control,
      mainThread: true
    }, /*#__PURE__*/_react["default"].createElement(AuthRouter, null));
  };

  appOptions.messages = getLocaleMessages();
  appOptions.mock = true;
  appOptions.controlMapping = _yesCompReactNativeWeb.ControlMappings.defaultControlMapping;
  appOptions.debug = true;
  appOptions.util = _yesWeb.Util;
  appOptions.root = /*#__PURE__*/_react["default"].createElement(NavigatorListenerWrapper, null);
  return appOptions;
};

exports["default"] = _default;