"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.init = void 0;

var _yes = require("yes");

var _baidupush = _interopRequireDefault(require("./baidupush"));

var _jpush = _interopRequireDefault(require("./jpush"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var ProjectConfig = null;

var _init = function _init() {
  //baidu推送
  if (ProjectConfig.baidupush && ProjectConfig.baidupush.apiKey) {
    _baidupush["default"].init(ProjectConfig.baidupush.apiKey);

    return;
  } //极光推送


  if (ProjectConfig.jpush) {
    _jpush["default"].init();

    return;
  }
};

var _uninit = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(ProjectConfig.baidupush && ProjectConfig.baidupush.apiKey)) {
              _context.next = 3;
              break;
            }

            _context.next = 3;
            return _baidupush["default"].uninit();

          case 3:
            if (!ProjectConfig.jpush) {
              _context.next = 6;
              break;
            }

            _context.next = 6;
            return _jpush["default"].uninit();

          case 6:
            _yes.AppDispatcher.dispatch({
              type: 'LOGOUT'
            });

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function _uninit() {
    return _ref.apply(this, arguments);
  };
}();

var init = function init(cfg) {
  ProjectConfig = cfg;

  _yes.AppDispatcher.register(function (action) {
    switch (action.type) {
      case 'LOGINED':
        //登录之后需要注册deviceId
        _init();

        break;

      case 'XIEXINLOGOUT':
        //登出之后需要注销deviceId
        _uninit();

        break;
    }
  });
};

exports.init = init;