"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _yigopushpatch = require("./yigopushpatch");

var _yesPlatform = require("yes-platform");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var registrationID = null;
document.addEventListener("jpush.openNotification", function (event) {
  console.log(event);
  var extra = null;

  if (device.platform == "Android") {
    extra = event.extras;
  } else {
    extra = event;
  }

  if (extra.messageType) {
    if (extra.messageType === 'openForm') {
      var _extra = extra,
          formKey = _extra.formKey,
          oid = _extra.oid;

      if (formKey && oid) {
        _yesPlatform.History.push("card/YES/".concat(formKey, "/").concat(oid, "/DEFAULT"));
      }
    }

    if (extra.messageType === 'openWorkitem') {
      var _extra2 = extra,
          workitemId = _extra2.workitemId;

      if (workitemId) {
        _yesPlatform.History.push("card/WORKITEM/".concat(workitemId, "/false/true/true"));
      }
    }
  }
}, false);

function init() {
  if (window.JPush) {
    JPush.init();
    JPush.getRegistrationID(function (rId) {
      if (rId) {
        console.log("JPushPlugin:registrationID is " + rId);
        registrationID = rId;
        (0, _yigopushpatch.register)(rId, 'jpush');
        JPush.resetBadge();
      }
    });
  } else {
    console.log("JPush env missing!");
  }
}

function uninit() {
  return _uninit.apply(this, arguments);
}

function _uninit() {
  _uninit = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!registrationID) {
              _context.next = 3;
              break;
            }

            _context.next = 3;
            return (0, _yigopushpatch.unregister)(registrationID, 'jpush');

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _uninit.apply(this, arguments);
}

var _default = {
  init: init,
  uninit: uninit
};
exports["default"] = _default;