"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _native = require("@react-navigation/native");

var _stack = require("@react-navigation/stack");

var _bottomTabs = require("@react-navigation/bottom-tabs");

var _materialTopTabs = require("@react-navigation/material-top-tabs");

var _Element = _interopRequireDefault(require("../template/Element"));

var _DynamicView = _interopRequireDefault(require("../DynamicView"));

var _WorkitemView = _interopRequireDefault(require("../WorkitemView"));

var _generateRouteComponent = _interopRequireDefault(require("../util/generateRouteComponent"));

var _getPathFromState = _interopRequireDefault(require("./getPathFromState"));

var _getStateFromPath = _interopRequireDefault(require("./getStateFromPath"));

var _getActionFromState = _interopRequireDefault(require("./getActionFromState"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

// import { generateKey } from '@react-navigation/core/lib/module/routers/KeyGenerator';
// import { StackViewStyleInterpolator } from 'react-navigation-stack';
// function injectStackNavigator(navigator) {
//     const oldFunc = navigator.router.getActionForPathAndParams;
//     navigator.router.getActionForPathAndParams = function () {
//         const action = oldFunc.apply(this, arguments);
//         if (action && action.action) {
//             action.action.key = action.action.key || generateKey();
//         }
//         return action;
//     }
// }
var defaultCardRoute = [// DynamicDetail: {
//     screen: DynamicView,
//     path: 'YESMOBILE/:metaKey/:id/:status',
// },
{
  key: 'YigoForm',
  screen: _DynamicView["default"],
  path: 'card/YES/:metaKey/:id/:status'
}, {
  key: 'YigoFormWithParent',
  screen: _DynamicView["default"],
  path: 'card/YES/:metaKey/:id/:status/:parent'
}, {
  key: 'Workitem',
  screen: _WorkitemView["default"],
  path: 'card/WORKITEM/:wid/:onlyOpen/:loadInfo'
} // WorkitemM: {
//     screen: WorkitemView,
//     path: 'WORKITEMM/:wid/:onlyOpen/:loadInfo/:msg',
// },
]; // const defaultModalRoute = {
//     DynamicDetail: {
//         screen: DynamicView,
//         path: 'YESMOBILE/:metaKey/:id/:status',
//     },
//     DynamicDetail1: {
//         screen: DynamicView,
//         path: 'YES/:metaKey/:id/:status',
//     },
//     Workitem: {
//         screen: WorkitemView,
//         path: 'WORKITEM/:wid/:onlyOpen/:loadInfo',
//     },
//     WorkitemM: {
//         screen: WorkitemView,
//         path: 'WORKITEMM/:wid/:onlyOpen/:loadInfo/:msg',
//     },
// };

var buildTabNavigator = function buildTabNavigator(tabConfig) {
  var tabs = [];

  var _iterator = _createForOfIteratorHelper(tabConfig.tabs),
      _step;

  try {
    var _loop = function _loop() {
      var tab = _step.value;
      var page = buildScreen(tab);

      if (!page.navigationOptions) {
        page.navigationOptions = function (_ref) {
          var navigation = _ref.navigation;
          return {
            tabBarIcon: tab.icon ? function (_ref2) {
              var tintColor = _ref2.tintColor,
                  focused = _ref2.focused,
                  horizontal = _ref2.horizontal;
              var meta = {
                type: 'element',
                elementType: 'IconFont',
                elementProps: {
                  name: tab.icon,
                  size: 22,
                  style: {
                    color: focused ? '#008CD7' : '#aaa'
                  }
                }
              };
              return /*#__PURE__*/_react["default"].createElement(_Element["default"], {
                meta: meta
              }); // <IconFontIcon
              //     name={tab.icon}
              //     size={22}
              //     style={{ color: focused ? '#008CD7' : '#aaa' }}
              // />
            } : null,
            tabBarLabel: tab.label
          };
        };
      }

      tabs.push({
        component: page,
        options: page.navigationOptions,
        name: tab.key
      }); // tabs[tab.key] = page;
    };

    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      _loop();
    } // if (!tabConfig.tabPosition || tabConfig.tabPosition === "top") {

  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  var tabBarPosition = tabConfig.tabPosition || 'top';
  var indicatorStyle = {};

  if (tabBarPosition === 'bottom') {
    // indicatorStyle.display = 'none';
    // top: 0,
    Object.assign(indicatorStyle, {
      top: 0
    });
  }

  var navigatorProps = {};

  if (tabConfig.tabbarElement) {
    navigatorProps.tabBar = function (props) {
      return /*#__PURE__*/_react["default"].createElement(_Element["default"], _extends({}, props, {
        meta: tabConfig.tabbarElement
      }));
    };
  }

  if (tabBarPosition === 'bottom') {
    var BottomTab = (0, _bottomTabs.createBottomTabNavigator)();
    return function () {
      return /*#__PURE__*/_react["default"].createElement(BottomTab.Navigator, _extends({
        initialRouteName: tabConfig.tabs[0].key,
        headerMode: "none",
        tabBarOptions: {
          labelPosition: 'below-icon',
          labelStyle: {
            fontSize: 14,
            margin: 0
          },
          activeBackgroundColor: tabConfig.activeBackgroundColor || 'white',
          activeTintColor: tabConfig.activeTintColor || '#008CD7',
          inactiveBackgroundColor: tabConfig.inactiveBackgroundColor || 'white',
          inactiveTintColor: tabConfig.inactiveTintColor || '#aaa',
          showLabel: tabConfig.showLabel,
          showIcon: tabConfig.showIcon,
          style: {
            backgroundColor: 'white'
          }
        }
      }, navigatorProps), tabs.map(function (tab) {
        return /*#__PURE__*/_react["default"].createElement(BottomTab.Screen, tab);
      }));
    };
    return (0, _bottomTabs.createBottomTabNavigator)(tabs, _objectSpread({
      initialRouteName: tabConfig.tabs[0].key,
      headerMode: 'none',
      swipeEnabled: true,
      tabBarOptions: {
        labelStyle: {
          fontSize: 14,
          margin: 0
        },
        indicatorStyle: _objectSpread({
          backgroundColor: tabConfig.indicatorColor || '#008CD7'
        }, indicatorStyle),
        upperCaseLabel: false,
        activeBackgroundColor: tabConfig.activeBackgroundColor || 'white',
        activeTintColor: tabConfig.activeTintColor || '#008CD7',
        inactiveBackgroundColor: tabConfig.inactiveBackgroundColor || 'white',
        inactiveTintColor: tabConfig.inactiveTintColor || '#aaa',
        showLabel: tabConfig.showLabel,
        showIcon: tabConfig.showIcon,
        style: {
          backgroundColor: 'white'
        }
      },
      tabBarPosition: tabBarPosition
    }, navigatorProps));
  }

  return (0, _materialTopTabs.createMaterialTopTabNavigator)(tabs, _objectSpread({
    // headerMode: 'none',
    title: "1111",
    swipeEnabled: true,
    initialRouteName: tabConfig.tabs[0].key,
    tabBarOptions: {
      labelStyle: {
        fontSize: 14,
        margin: 0
      },
      indicatorStyle: _objectSpread({
        backgroundColor: tabConfig.indicatorColor || '#008CD7'
      }, indicatorStyle),
      upperCaseLabel: false,
      activeBackgroundColor: tabConfig.activeBackgroundColor || 'white',
      activeTintColor: tabConfig.activeTintColor || '#008CD7',
      inactiveBackgroundColor: tabConfig.inactiveBackgroundColor || 'white',
      inactiveTintColor: tabConfig.inactiveTintColor || '#aaa',
      showLabel: tabConfig.showLabel,
      showIcon: tabConfig.showIcon,
      style: {
        backgroundColor: 'white'
      }
    },
    tabBarPosition: tabBarPosition
  }, navigatorProps));
};

var buildYIGOBillformScreen = function buildYIGOBillformScreen(config) {
  return (0, _generateRouteComponent["default"])({
    formKey: config.formKey,
    // title: ({ focused, tintColor }) =>
    //     <RejectBadget><Text style={{ fontSize: 16, color: tintColor }}>{formatMessage('Reject List')}</Text></RejectBadget>,
    key: config.key,
    oid: config.oid,
    status: config.status || 'DEFAULT'
  });
};

var buildControlScreen = function buildControlScreen(config) {
  // const Control = Controls[config.control];
  // return () => <Control {...config.controlProps} />
  var meta = {
    type: 'element',
    elementType: config.control,
    elementProps: config.controlProps
  };
  return function () {
    return /*#__PURE__*/_react["default"].createElement(_Element["default"], {
      meta: meta
    });
  };
};

var buildScreen = function buildScreen(config) {
  switch (config.type) {
    case 'tab':
      return buildTabNavigator(config);

    case 'billform':
      return buildYIGOBillformScreen(config);

    case 'button':
      var result = function result() {
        return null;
      };

      result.navigationOptions = {
        // tabBarButtonComponent: Controls[config.tabControl],
        tabBarButton: function tabBarButton() {
          // const C = Controls[config.tabControl];
          // return <C />
          return /*#__PURE__*/_react["default"].createElement(_Element["default"], {
            meta: {
              type: 'element',
              elementType: config.tabControl
            }
          });
        }
      };
      return result;

    default:
      return buildControlScreen(config);
  }
};

var _default = function _default(config) {
  var customRoute = [];
  var initialRouteName = null;
  var linking = {
    screens: {}
  };
  defaultCardRoute.forEach(function (r) {
    linking.screens[r.key] = {
      path: r.path
    };
  });

  var _iterator2 = _createForOfIteratorHelper(config),
      _step2;

  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var r = _step2.value;
      var route = {};
      var Screen = buildScreen(r);
      route.screen = Screen;
      route.path = r.path;
      route.key = r.key; // customRoute[r.key] = route;

      customRoute.push(route);

      if (r.isRoot) {
        initialRouteName = r.key;
      }

      linking.screens[r.key] = {
        path: r.path
      };
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }

  var Stack = (0, _stack.createStackNavigator)();

  var mainCardNavigator = function mainCardNavigator() {
    return /*#__PURE__*/_react["default"].createElement(Stack.Navigator, {
      headerMode: "none"
    }, defaultCardRoute.map(function (card) {
      return /*#__PURE__*/_react["default"].createElement(Stack.Screen, {
        name: card.key,
        component: card.screen
      });
    }));
  }; // const mainCardNavigator = createStackNavigator(
  //     defaultCardRoute,
  //     {
  //         headerMode: 'none',
  //         cardStyle: {
  //             flex: 1
  //         },
  //         defaultNavigationOptions: {
  //             header: null,
  //             // gesturesEnabled: true,
  //             animationEnabled: true,
  //         },
  //     }
  // )
  // const mainModalNavigator = createStackNavigator(
  //     defaultModalRoute,
  //     {
  //         defaultNavigationOptions: {
  //             header: null,
  //         },
  //         cardStyle: {
  //             backgroundColor: 'transparent',
  //         },
  //         initialRouteName,
  //         mode: 'modal',
  //         headerMode: 'none',
  //         transparentCard: true,
  //     }
  // )
  // injectStackNavigator(mainModalNavigator);


  var MainNavigator = function MainNavigator() {
    return /*#__PURE__*/_react["default"].createElement(Stack.Navigator, {
      initialRouteName: initialRouteName,
      headerMode: "none"
    }, [].concat(customRoute, defaultCardRoute).map(function (r) {
      return /*#__PURE__*/_react["default"].createElement(Stack.Screen, {
        name: r.key,
        component: r.screen,
        options: {
          animationEnabled: true
        }
      });
    }));
  }; // const MainNavigator = createStackNavigator(
  //     {
  //         ...customRoute,
  //         Card: {
  //             screen: mainCardNavigator,
  //             path: 'card',
  //         },
  //         // ...defaultModalRoute,
  //         // Modal: {
  //         //     screen: mainModalNavigator,
  //         //     path: 'modal',
  //         // }
  //     },
  //     {
  //         defaultNavigationOptions: {
  //             header: null,
  //             // gesturesEnabled: true,
  //             animationEnabled: true,
  //         },
  //         cardStyle: {
  //             backgroundColor: 'transparent',
  //         },
  //         initialRouteName,
  //         mode: 'modal',
  //         headerMode: 'none',
  //         transparentCard: true,
  //     },
  // );
  // injectStackNavigator(MainNavigator);


  linking.initialRouteName = initialRouteName;
  return function () {
    return /*#__PURE__*/_react["default"].createElement(_native.NavigationContainer, {
      linking: {
        enabled: true,
        getStateFromPath: _getStateFromPath["default"],
        getPathFromState: _getPathFromState["default"],
        getActionFromState: _getActionFromState["default"],
        prefixes: ['://'],
        config: linking
      }
    }, /*#__PURE__*/_react["default"].createElement(MainNavigator, null));
  };
};

exports["default"] = _default;