"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.YIGOFormTitle = exports.WithStyle = exports.WithoutBack = exports.CanBack = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _export = require("yes-framework/export");

var _FontAwesome = _interopRequireDefault(require("react-native-vector-icons/Fonts/FontAwesome.ttf"));

var _webutil = require("yes-web/dist/webutil");

var _StoryContext = _interopRequireDefault(require("yes-comp-react-native-web/stories/StoryContext"));

var _AppWrapper = _interopRequireDefault(require("../AppWrapper"));

var _index = require("../config/index");

var _control = _interopRequireDefault(require("../config/control"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

(0, _webutil.injectFont)(_FontAwesome["default"], 'FontAwesome');
var _default = {
  title: 'yes-framework/Header',
  component: _export.Header
};
exports["default"] = _default;

var Template = function Template(args) {
  return /*#__PURE__*/_react["default"].createElement(_AppWrapper["default"], {
    control: _control["default"],
    projectCfg: _index.ProjectCfg
  }, /*#__PURE__*/_react["default"].createElement(_StoryContext["default"], null, /*#__PURE__*/_react["default"].createElement(_export.Header, args)));
};

var argTypes = {
  titleMode: {
    description: 'Title模式flex-android,absolute-ios,使用自定义title控件不起作用',
    defaultValue: 'flex',
    control: {
      type: 'radio',
      options: ['flex', 'absolute']
    }
  },
  mode: {
    control: {
      type: 'radio',
      options: ['dark', 'light']
    }
  }
};
var CanBack = Template.bind({});
exports.CanBack = CanBack;
CanBack.argTypes = argTypes;
CanBack.args = {
  titleMode: 'flex',
  canBack: true,
  title: "Title",
  headerStyle: {},
  titleStyle: {},
  textStyle: {},
  mode: 'dark'
};
var WithoutBack = Template.bind({});
exports.WithoutBack = WithoutBack;
WithoutBack.args = {
  titleMode: 'flex',
  canBack: false,
  title: "Title",
  headerStyle: {},
  titleStyle: {},
  textStyle: {},
  mode: 'dark'
};
var WithStyle = Template.bind({});
exports.WithStyle = WithStyle;
WithStyle.args = {
  titleMode: 'flex',
  canBack: false,
  title: "Title",
  headerStyle: {
    "boder": "none"
  },
  titleStyle: {
    "backgroundColor": "red",
    "flex": 1
  },
  textStyle: {
    "color": "white"
  },
  mode: 'dark'
};
var YIGOFormTitle = Template.bind({});
exports.YIGOFormTitle = YIGOFormTitle;
YIGOFormTitle.argTypes = argTypes;
YIGOFormTitle.args = {
  titleMode: 'flex',
  canBack: true,
  title: "Title",
  headerStyle: {},
  titleStyle: {},
  textStyle: {},
  mode: 'dark',
  titleElement: {
    type: 'element',
    elementType: 'FormTitle'
  }
};