"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Line = exports.Bar = exports.Pie = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _ygEcharts = require("yg-echarts");

var _StoryWrapper = _interopRequireDefault(require("../StoryWrapper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = {
  title: 'yes-framework/grid/Chart',
  component: _ygEcharts.GridChart
};
exports["default"] = _default;

var Template = function Template(args) {
  return /*#__PURE__*/_react["default"].createElement(_StoryWrapper["default"], null, /*#__PURE__*/_react["default"].createElement(_ygEcharts.GridChart, args));
};

var argTypes = {};
var Pie = Template.bind({});
exports.Pie = Pie;
Pie.argTypes = argTypes;
Pie.args = {
  yigoid: 'grid1',
  title: {
    text: 'Pie'
  },
  legend: {},
  style: {
    flex: 1,
    width: '100%'
  },
  slice: ['title', 'badget'],
  series: [{
    type: 'pie',
    dataColumn: 'badget'
  }]
};
var Bar = Template.bind({});
exports.Bar = Bar;
Bar.argTypes = argTypes;
Bar.args = {
  yigoid: 'grid1',
  title: {
    text: 'Bar'
  },
  "xAxis": {
    "type": "category"
  },
  "yAxis": {
    "type": "value"
  },
  legend: {},
  style: {
    flex: 1,
    width: '100%'
  },
  slice: ['title', 'badget'],
  series: [{
    type: 'bar',
    dataColumn: 'badget'
  }]
};
var Line = Template.bind({});
exports.Line = Line;
Line.argTypes = argTypes;
Line.args = {
  yigoid: 'grid1',
  title: {
    text: 'Line'
  },
  "xAxis": {
    "type": "category"
  },
  "yAxis": {
    "type": "value"
  },
  legend: {},
  style: {
    flex: 1,
    width: '100%'
  },
  slice: ['title', 'badget'],
  series: [{
    type: 'line',
    dataColumn: 'badget'
  }]
};