"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WithLeftElement = exports.WithRightElement = exports.WithHeader = exports.WithNewButton = exports.WithSelect = exports.Base = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _StoryWrapper = _interopRequireDefault(require("../StoryWrapper"));

var _export = require("../../export");

var _reactNative = require("react-native");

var _yesIntf = require("yes-intf");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var RowView = (0, _yesIntf.GridRowWrap)(function (_ref) {
  var rowIndex = _ref.rowIndex,
      style = _ref.style;
  var bkColor = {
    backgroundColor: rowIndex % 2 ? 'white' : 'gray'
  };
  return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
    style: [style, bkColor]
  }, /*#__PURE__*/_react["default"].createElement(_export.ListText, {
    yigoid: "title"
  }));
});
var _default = {
  title: 'yes-framework/grid/GridView',
  component: _export.GridView
};
exports["default"] = _default;

var Template = function Template(args) {
  return /*#__PURE__*/_react["default"].createElement(_StoryWrapper["default"], null, /*#__PURE__*/_react["default"].createElement(_export.GridView, args));
};

var data = [];
var argTypes = {};
var Base = Template.bind({});
exports.Base = Base;
Base.argTypes = argTypes;
Base.args = {
  yigoid: 'grid1',
  primaryKey: 'title',
  secondKey: ['subTitle'],
  tertiaryKey: ['dict2'],
  useBodyScroll: true,
  rowHeight: 76,
  keyField: 'id',
  RowElement: /*#__PURE__*/_react["default"].createElement(RowView, {
    style: {
      height: 76
    }
  }),
  rightActions: [{
    text: '显示',
    columnKey: 'aaa'
  }],
  leftActions: [{
    text: '明细',
    columnKey: 'aaa'
  }]
};
var WithSelect = Template.bind({});
exports.WithSelect = WithSelect;
WithSelect.argTypes = argTypes;
WithSelect.args = {
  yigoid: 'grid1',
  primaryKey: 'title',
  secondKey: ['subTitle'],
  tertiaryKey: ['dict2'],
  keyField: 'id',
  useBodyScroll: false,
  style: {
    flex: 1
  },
  rowHeight: 76,
  removeable: false,
  clickMode: 'select',
  leftElement: {
    type: 'element',
    elementType: 'GridSelect',
    elementProps: {
      yigoid: 'select'
    }
  }
};
var WithNewButton = Template.bind({});
exports.WithNewButton = WithNewButton;
WithNewButton.argTypes = argTypes;
WithNewButton.args = {
  yigoid: 'grid1',
  primaryKey: 'title',
  secondKey: ['subTitle'],
  tertiaryKey: ['dict2'],
  useBodyScroll: true,
  leftElement: {
    type: 'element',
    elementType: 'GridSelect',
    elementProps: {
      yigoid: 'select'
    }
  },
  newElement: {
    type: 'element',
    elementType: 'NativeButton',
    elementProps: {
      title: "新增"
    }
  }
};
var WithHeader = Template.bind({});
exports.WithHeader = WithHeader;
WithHeader.argTypes = argTypes;
WithHeader.args = {
  yigoid: 'grid1',
  primaryKey: 'title',
  secondKey: ['subTitle'],
  tertiaryKey: ['dict2'],
  useBodyScroll: true,
  showHead: true,
  headTitle: "Title",
  headExtra: {
    type: 'element',
    elementType: 'AwesomeFontIcon',
    elementProps: {
      name: 'star',
      size: 20,
      style: {
        color: 'red',
        paddingRight: 12
      }
    }
  },
  leftElement: {
    type: 'element',
    elementType: 'GridSelect',
    elementProps: {
      yigoid: 'select'
    }
  }
};
var WithRightElement = Template.bind({});
exports.WithRightElement = WithRightElement;
WithRightElement.argTypes = argTypes;
WithRightElement.args = {
  yigoid: 'grid1',
  primaryKey: 'title',
  secondKey: ['subTitle'],
  tertiaryKey: ['dict2'],
  rightElement: {
    type: 'element',
    elementType: 'ListComponents.ListImage',
    elementProps: {
      yigoid: 'img',
      style: {
        width: 60,
        height: 40
      },
      containerStyle: {
        justifyContent: 'center',
        paddingRight: 10
      }
    }
  },
  useBodyScroll: true
};
var WithLeftElement = Template.bind({});
exports.WithLeftElement = WithLeftElement;
WithLeftElement.argTypes = argTypes;
WithLeftElement.args = {
  yigoid: 'grid1',
  primaryKey: 'title',
  secondKey: ['subTitle'],
  tertiaryKey: ['dict2'],
  rightElement: {
    type: 'element',
    elementType: 'ListComponents.ListImage',
    elementProps: {
      yigoid: 'img',
      style: {
        width: 40,
        height: 40,
        borderRadius: '50%'
      },
      containerStyle: {
        justifyContent: 'center',
        paddingRight: 10
      }
    }
  },
  leftElement: {
    type: 'element',
    elementType: 'ListComponents.ListImage',
    elementProps: {
      yigoid: 'img',
      style: {
        width: 40,
        height: 40,
        borderRadius: 10
      },
      containerStyle: {
        justifyContent: 'center',
        paddingRight: 12
      }
    }
  },
  useBodyScroll: true
};