"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withGridSelect = exports.Base = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _ListWithQuery = _interopRequireDefault(require("../../template/ListTemplate/ListWithQuery"));

var _FontAwesome = _interopRequireDefault(require("react-native-vector-icons/Fonts/FontAwesome.ttf"));

var _webutil = require("yes-web/dist/webutil");

require("antd-mobile/dist/antd-mobile.css");

var _StoryWrapper = _interopRequireDefault(require("../StoryWrapper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

(0, _webutil.injectFont)(_FontAwesome["default"], 'FontAwesome');
var _default = {
  title: 'yes-framework/template/ListWithQuery',
  component: _ListWithQuery["default"]
};
exports["default"] = _default;

var Template = function Template(args) {
  return /*#__PURE__*/_react["default"].createElement(_StoryWrapper["default"], null, /*#__PURE__*/_react["default"].createElement(_ListWithQuery["default"], args));
};

var argTypes = {};
var Base = Template.bind({});
exports.Base = Base;
Base.argTypes = argTypes;
Base.args = {
  "head": {
    "type": "element",
    "elementType": "Header",
    "elementProps": {
      "canBack": true,
      "titleElement": {
        "type": "element",
        "elementType": "FormTitle",
        "elementProps": {
          "containerStyle": {
            "alignItems": "center",
            "justifyContent": "center"
          }
        }
      }
    }
  },
  queryItems: [{
    text: '单据编号',
    content: {
      "type": "element",
      "elementType": "Text",
      "elementProps": {
        "yigoid": 'map1',
        "clearButtonMode": true,
        "scanMode": true,
        textStyles: {
          paddingLeft: 24,
          paddingRight: 12,
          borderWidth: 1,
          borderColor: 'lightgray',
          borderRadius: 20
        },
        layoutStyles: {
          paddingLeft: 12,
          marginRight: 12,
          paddingTop: 8,
          paddingBottom: 8
        }
      }
    }
  }, {
    text: '单据类型',
    content: {
      "type": "element",
      "elementType": "QueryContainer",
      "elementProps": {
        "supportClear": true,
        "clearControls": ['BillType_NODB4Other'],
        "content": {
          "type": "element",
          "elementType": "PopoverCombobox",
          "elementProps": {
            "yigoid": 'combobox1',
            inline: true
          }
        }
      }
    }
  }, {
    text: '制单人',
    content: {
      "type": "element",
      "elementType": "QueryContainer",
      "elementProps": {
        "supportClear": true,
        "clearControls": ['Creator_NODB4Other'],
        "content": {
          "type": "element",
          "elementType": "ChainDict",
          "elementProps": {
            "yigoid": 'dict1',
            inline: true,
            hideTitle: true
          }
        }
      }
    }
  }],
  list: {
    "type": "element",
    "elementType": "GridView",
    "elementProps": {
      yigoid: 'grid1',
      "primaryKey": "title",
      "secondKey": ["subTitle"],
      useBodyScroll: false,
      style: {
        flex: 1
      }
    }
  }
};
var withGridSelect = Template.bind({});
exports.withGridSelect = withGridSelect;
withGridSelect.args = {
  "head": {
    "type": "element",
    "elementType": "Header",
    "elementProps": {
      "canBack": true,
      "titleElement": {
        "type": "element",
        "elementType": "FormTitle",
        "elementProps": {
          "containerStyle": {
            "alignItems": "center",
            "justifyContent": "center"
          }
        }
      }
    }
  },
  "foot": {
    "type": "element",
    "elementType": "GridBatchOperate",
    "elementProps": {
      "yigoid": "grid1",
      "optKey": "BatchAudit",
      "autoHide": false,
      "supportSelectAll": true,
      "title": "审批"
    }
  },
  queryItems: [{
    text: '单据编号',
    content: {
      "type": "element",
      "elementType": "Text",
      "elementProps": {
        "yigoid": 'map1',
        "clearButtonMode": true,
        "scanMode": true,
        textStyles: {
          paddingLeft: 24,
          paddingRight: 12,
          borderWidth: 1,
          borderColor: 'lightgray',
          borderRadius: 20
        },
        layoutStyles: {
          paddingLeft: 12,
          marginRight: 12,
          paddingTop: 8,
          paddingBottom: 8
        }
      }
    }
  }, {
    text: '单据类型',
    content: {
      "type": "element",
      "elementType": "QueryContainer",
      "elementProps": {
        "supportClear": true,
        "clearControls": ['BillType_NODB4Other'],
        "content": {
          "type": "element",
          "elementType": "PopoverCombobox",
          "elementProps": {
            "yigoid": 'combobox1',
            inline: true
          }
        }
      }
    }
  }, {
    text: '制单人',
    content: {
      "type": "element",
      "elementType": "QueryContainer",
      "elementProps": {
        "supportClear": true,
        "clearControls": ['Creator_NODB4Other'],
        "content": {
          "type": "element",
          "elementType": "ChainDict",
          "elementProps": {
            "yigoid": 'dict1',
            inline: true,
            hideTitle: true
          }
        }
      }
    }
  }],
  list: {
    "type": "element",
    "elementType": "GridView",
    "elementProps": {
      yigoid: 'grid1',
      "primaryKey": "title",
      "secondKey": ["subTitle"],
      useBodyScroll: false,
      style: {
        flex: 1
      }
    }
  }
};