"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _defaultTemplateMapping = _interopRequireDefault(require("../defaultTemplateMapping"));

var _Element = _interopRequireDefault(require("../Element"));

var _AutofitScrollView = _interopRequireDefault(require("../../controls/Container/AutofitScrollView"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var styles = _reactNative.StyleSheet.create({
  container: {
    flex: 1
  },
  errorContainer: {
    flex: 1,
    justifyContent: 'center',
    alignItems: 'center',
    paddingLeft: 16,
    paddingRight: 16
  },
  topBackground: {
    position: 'absolute',
    top: -1,
    left: 0,
    right: 0,
    height: 200
  },
  paddingBottom: {
    paddingBottom: 20
  },
  mask: {
    position: 'absolute',
    height: '100%',
    width: '100%',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    zIndex: 1,
    backgroundColor: 'rgba(245,245,245,0.5)'
  }
});

var defaultHeader = {
  "type": "element",
  "elementType": "Header",
  "elementProps": {
    "canBack": true,
    "titleElement": {
      "type": "element",
      "elementType": "FormTitle",
      "elementProps": {
        "containerStyle": {
          "alignItems": "center",
          "justifyContent": "center"
        }
      }
    }
  }
};

var AutoTemplate = /*#__PURE__*/function (_PureComponent) {
  _inherits(AutoTemplate, _PureComponent);

  var _super = _createSuper(AutoTemplate);

  function AutoTemplate() {
    _classCallCheck(this, AutoTemplate);

    return _super.apply(this, arguments);
  }

  _createClass(AutoTemplate, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          items = _this$props.items,
          action = _this$props.action,
          error = _this$props.error,
          errorMsg = _this$props.errorMsg,
          formStatus = _this$props.formStatus,
          containerStyle = _this$props.containerStyle,
          backgroundImg = _this$props.backgroundImg; // const form = this.context.getBillForm();
      // if (form) {

      var actionButton = this.context.createElement(action);
      var foot = this.context.createElement(this.props.foot);
      var head = this.context.createElement(this.props.head);

      if (error) {
        return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
          style: styles.container
        }, head, /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
          style: styles.errorContainer
        }, /*#__PURE__*/_react["default"].createElement(_reactNative.Text, null, errorMsg.message)));
      }

      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: styles.container
      }, backgroundImg ? /*#__PURE__*/_react["default"].createElement(_reactNative.ImageBackground, {
        style: styles.topBackground,
        source: backgroundImg
      }) : null, head, /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [styles.container, containerStyle]
      }, /*#__PURE__*/_react["default"].createElement(_AutofitScrollView["default"], {
        style: styles.paddingBottom
      }, formStatus && formStatus != 'ok' ? /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: styles.mask
      }, /*#__PURE__*/_react["default"].createElement(_reactNative.ActivityIndicator, null)) : null, items.map(function (item) {
        return /*#__PURE__*/_react["default"].createElement(_Element["default"], {
          meta: item
        });
      })), actionButton), foot);
    }
  }]);

  return AutoTemplate;
}(_react.PureComponent);

AutoTemplate.contextTypes = {
  createElement: _propTypes["default"].func
};
AutoTemplate.defaultProps = {
  head: defaultHeader
};

_defaultTemplateMapping["default"].reg('auto', AutoTemplate);

var _default = AutoTemplate;
exports["default"] = _default;