"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _defaultTemplateMapping = _interopRequireDefault(require("../defaultTemplateMapping"));

var _reactNative = require("react-native");

var _yes = require("yes");

var _yesIntf = require("yes-intf");

var _FontAwesome = _interopRequireDefault(require("react-native-vector-icons/FontAwesome"));

var _yesPlatform = require("yes-platform");

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var styles = _reactNative.StyleSheet.create({
  mask: {
    position: 'absolute',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0,
    zIndex: 1,
    justifyContent: 'center',
    backgroundColor: 'rgba(211,211,211,0.5)'
  },
  queryBlock: {
    flexDirection: 'row',
    height: 48
  },
  queryitemwrap: {
    flex: 1,
    justifyContent: 'center'
  },
  advqueryitemwrap: {
    justifyContent: 'center',
    width: 50
  },
  item: {
    flexDirection: 'row',
    alignItems: 'center',
    justifyContent: 'center'
  },
  query: {
    position: 'absolute',
    zIndex: 2,
    top: 0,
    left: 0,
    backgroundColor: 'white',
    right: 0,
    maxHeight: 300
  },
  selectedText: {
    color: '#108EE9'
  }
});

var QueryItem = function QueryItem(_ref) {
  var selected = _ref.selected,
      item = _ref.item,
      onPress = _ref.onPress;

  var doPress = function doPress() {
    onPress && onPress(item);
  };

  return /*#__PURE__*/_react["default"].createElement(_reactNative.TouchableOpacity, {
    style: styles.queryitemwrap,
    onPress: doPress
  }, /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
    style: styles.item
  }, /*#__PURE__*/_react["default"].createElement(_reactNative.Text, {
    style: [selected ? styles.selectedText : styles.queryItemText]
  }, item.text), /*#__PURE__*/_react["default"].createElement(_FontAwesome["default"], {
    style: [selected ? styles.selectedText : styles.queryItemText],
    name: selected ? 'angle-up' : 'angle-down'
  })));
};

var AdvanceQuery = function AdvanceQuery(_ref2) {
  var item = _ref2.item,
      selected = _ref2.selected,
      onPress = _ref2.onPress;

  var doPress = function doPress() {
    onPress && onPress(item);
  };

  return /*#__PURE__*/_react["default"].createElement(_reactNative.TouchableOpacity, {
    style: styles.advqueryitemwrap,
    onPress: doPress
  }, /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
    style: styles.item
  }, /*#__PURE__*/_react["default"].createElement(_FontAwesome["default"], {
    name: "filter"
  })));
};

var QueryBlock = /*#__PURE__*/function (_PureComponent) {
  _inherits(QueryBlock, _PureComponent);

  var _super = _createSuper(QueryBlock);

  function QueryBlock() {
    var _this;

    _classCallCheck(this, QueryBlock);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.state = {
      selectedItem: null
    };

    _this.onQuery = function (item) {
      if (item === _this.state.selectedItem) {
        _this.setState({
          selectedItem: null
        });

        _this.props.onQuery && _this.props.onQuery(null);
      } else {
        _this.setState({
          selectedItem: item
        });

        _this.props.onQuery && _this.props.onQuery(item);
      }
    };

    _this.onAdvanceQuery = function () {
      _this.onQuery(null);

      _this.props.onAdvanceQuery && _this.props.onAdvanceQuery();
    };

    _this.reset = function () {
      _this.onQuery(null);
    };

    return _this;
  }

  _createClass(QueryBlock, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          items = _this$props.items,
          advanceQuery = _this$props.advanceQuery;
      var selectedItem = this.state.selectedItem;
      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: styles.queryBlock
      }, items.map(function (item) {
        return /*#__PURE__*/_react["default"].createElement(QueryItem, {
          item: item,
          selected: selectedItem === item,
          onPress: _this2.onQuery
        });
      }), advanceQuery ? /*#__PURE__*/_react["default"].createElement(AdvanceQuery, {
        item: advanceQuery,
        onPress: this.props.onAdvanceQuery
      }) : null);
    }
  }]);

  return QueryBlock;
}(_react.PureComponent);

var ListWithQueryTemplate = /*#__PURE__*/function (_PureComponent2) {
  _inherits(ListWithQueryTemplate, _PureComponent2);

  var _super2 = _createSuper(ListWithQueryTemplate);

  function ListWithQueryTemplate() {
    var _this3;

    _classCallCheck(this, ListWithQueryTemplate);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this3 = _super2.call.apply(_super2, [this].concat(args));
    _this3.state = {
      refreshing: false,
      showMask: false,
      showSlideMask: false,
      queryItem: null
    };
    _this3.onRefresh = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var refresh;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this3.setState({
                refreshing: true
              });

              _context.prev = 1;
              refresh = _this3.props.refresh;

              if (!(!refresh || refresh.type === 'form')) {
                _context.next = 6;
                break;
              }

              _context.next = 6;
              return _this3.props.reload();

            case 6:
              if (!(refresh && refresh.type === 'button')) {
                _context.next = 9;
                break;
              }

              _context.next = 9;
              return _this3.context.onControlClick(refresh.buttonId);

            case 9:
              if (!(refresh && refresh.type === 'opt')) {
                _context.next = 12;
                break;
              }

              _context.next = 12;
              return _this3.context.doOpt(refresh.optId);

            case 12:
              _context.next = 17;
              break;

            case 14:
              _context.prev = 14;
              _context.t0 = _context["catch"](1);
              console.log(_context.t0);

            case 17:
              _context.prev = 17;

              _this3.setState({
                refreshing: false
              });

              return _context.finish(17);

            case 20:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[1, 14, 17, 20]]);
    }));

    _this3.addListener = function () {
      if (!_this3.backHandler) {
        _yesPlatform.History.push("#ListWithQuery", false);

        _this3.backHandler = _yes.BackHandler.addPreEventListener(function () {
          // this.removeListener();
          _this3.onMaskClick();
        });
      }
    };

    _this3.removeListener = function () {
      _this3.backHandler && _this3.backHandler(); // this.onMaskClick();

      _this3.backHandler = null;
    };

    _this3.onAdvanceQuery = function () {
      var advanceQuery = _this3.props.advanceQuery;

      if (!advanceQuery) {
        return;
      }

      if (advanceQuery.type === 'button') {
        _this3.setState({
          queryItem: null,
          showMask: false,
          showSlideMask: false
        }); // this.ref && this.ref.reset();


        _this3.removeListener();

        _this3.context.onControlClick(advanceQuery.yigoid);
      } else {
        _this3.setState({
          queryItem: null,
          showMask: false,
          showSlideMask: true
        });

        _this3.addListener();
      }
    };

    _this3.onQuery = function (item) {
      if (item) {
        _this3.setState({
          showMask: true,
          queryItem: item,
          showSlideMask: false
        });

        _this3.addListener();
      } else {
        _this3.setState({
          showMask: false,
          queryItem: item,
          showSlideMask: false
        });

        _this3.removeListener();
      }
    };

    _this3.bindRef = function (ref) {
      _this3.ref = ref;
    };

    _this3.onMaskClick = function () {
      _this3.ref && _this3.ref.reset();
    };

    _this3.onPostQuery = function () {
      var _this3$props = _this3.props,
          queryType = _this3$props.queryType,
          queryId = _this3$props.queryId;

      _this3.onMaskClick();

      if (queryType === 'button') {
        _this3.context.onControlClick(queryId);
      }
    };

    return _this3;
  }

  _createClass(ListWithQueryTemplate, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.removeListener();
    }
  }, {
    key: "render",
    value: function render() {
      return this.buildChildren();
    }
  }, {
    key: "buildChildren",
    value: function buildChildren() {
      var _this$props2 = this.props,
          queryItems = _this$props2.queryItems,
          advanceQuery = _this$props2.advanceQuery,
          list = _this$props2.list,
          action = _this$props2.action,
          formStatus = _this$props2.formStatus,
          error = _this$props2.error,
          errorMsg = _this$props2.errorMsg,
          contentStyle = _this$props2.contentStyle,
          busying = _this$props2.busying; //reloading状态下不显示加载状态

      var _this$state = this.state,
          showMask = _this$state.showMask,
          showSlideMask = _this$state.showSlideMask,
          refreshing = _this$state.refreshing;
      var listEle = this.context.createElement(list, {
        onRefresh: this.onRefresh,
        refreshing: refreshing
      });
      var foot = this.context.createElement(this.props.foot);
      var head = this.context.createElement(this.props.head);
      var actionButton = this.context.createElement(action);

      if (!_react["default"].isValidElement(listEle)) {
        listEle = /*#__PURE__*/_react["default"].createElement(_yes.DynamicControl, _extends({
          designPositionBase: true,
          yigoid: list,
          debugStyle: {
            flex: 1
          },
          layoutStyles: {
            flex: 1
          },
          style: {
            flex: 1,
            marginLeft: 12
          }
        }, this.context.getControlProps(list)));
      }

      return /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: {
          flex: 1,
          backgroundColor: 'white'
        }
      }, this.context.createElement(head), /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [{
          flex: 1
        }]
      }, showSlideMask ? /*#__PURE__*/_react["default"].createElement(_reactNative.TouchableWithoutFeedback, {
        onPress: this.onMaskClick
      }, /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: styles.mask
      })) : null, showSlideMask && this.props.advanceQuery ? /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: styles.slide
      }, this.context.createElement(this.props.advanceQuery.content)) : null, /*#__PURE__*/_react["default"].createElement(QueryBlock, {
        ref: this.bindRef,
        onQuery: this.onQuery,
        onAdvanceQuery: this.onAdvanceQuery,
        items: queryItems,
        advanceQuery: advanceQuery
      }), /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: [{
          flex: 1
        }, contentStyle]
      }, formStatus && formStatus != 'ok' || busying ? /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: styles.mask
      }, /*#__PURE__*/_react["default"].createElement(_reactNative.ActivityIndicator, null)) : null, showMask ? /*#__PURE__*/_react["default"].createElement(_reactNative.TouchableWithoutFeedback, {
        onPress: this.onMaskClick,
        style: styles.mask
      }, /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: styles.mask
      })) : null, showMask && this.state.queryItem ? /*#__PURE__*/_react["default"].createElement(_reactNative.View, {
        style: styles.query
      }, this.context.createElement(this.state.queryItem.content, {
        onChange: this.onPostQuery
      })) : null, listEle, foot, actionButton)));
    }
  }]);

  return ListWithQueryTemplate;
}(_react.PureComponent);

ListWithQueryTemplate.contextTypes = {
  createElement: _propTypes["default"].func,
  onControlClick: _propTypes["default"].func,
  getControlProps: _propTypes["default"].func,
  doOpt: _propTypes["default"].func
};
ListWithQueryTemplate.defaultProps = {
  queryType: 'button'
};
var ListWithNavigation = (0, _yesIntf.internationalWrap)(ListWithQueryTemplate);
ListWithNavigation.caption = "单据列表模板(带过滤)";

_defaultTemplateMapping["default"].reg('listwithquery', ListWithNavigation);

var _default = ListWithNavigation;
exports["default"] = _default;