"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addShowModalEventListener = exports.showModal = exports.openModal = exports.newForm = exports.openForm = void 0;

var _yesPlatform = require("yes-platform");

var _eventemitter = _interopRequireDefault(require("eventemitter3"));

var _yesCore = require("yes-core");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var modalEventEmitter = new _eventemitter["default"]();

var openForm = function openForm(formKey, oid, status) {
  _yesPlatform.History.push("card/YES/".concat(formKey, "/").concat(oid, "/").concat(status));
};

exports.openForm = openForm;

var newForm = function newForm(formKey) {
  _yesPlatform.History.push("card/YES/".concat(formKey, "/new/NEW"));
};

exports.newForm = newForm;

var openModal = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(formKey, oid, status, params, showType) {
    var realOid;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            realOid = oid;

            if (!(oid === 'new')) {
              _context.next = 5;
              break;
            }

            _context.next = 4;
            return _yesCore.YIUI.RemoteService.applyNewOID();

          case 4:
            realOid = _context.sent;

          case 5:
            _yesPlatform.Util.showBillformInModal(formKey, realOid, status, params, showType);

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function openModal(_x, _x2, _x3, _x4, _x5) {
    return _ref.apply(this, arguments);
  };
}();

exports.openModal = openModal;

var showModal = function showModal(v) {
  modalEventEmitter.emit('show', v);
};

exports.showModal = showModal;

var addShowModalEventListener = function addShowModalEventListener(handler) {
  modalEventEmitter.addListener('show', modal);
};

exports.addShowModalEventListener = addShowModalEventListener;