"use strict";

var _yesCore = require("yes-core");

require("./exprhandlermap");

require("./baseexprhandler");

var ContainerExprHandler = _yesCore.YIUI.extend(_yesCore.YIUI.BaseExprHandler, {
  doCalcItemInit: function doCalcItemInit(meta) {},
  doEnableItemInit: function doEnableItemInit(meta) {},
  doVisibleItemInit: function doVisibleItemInit(meta, tree) {
    var self = this;
    var metaKey = meta.key;

    if (metaKey) {
      var item = self.createVisibleItem(metaKey, metaKey, VisibleItem.Head, meta.visible, meta.visibleDependency);
      tree.add(item);
    }

    var tabGroup = meta.tabGroup;

    if (tabGroup && tabGroup.items) {
      var itemSet = new VisibleItemSet(metaKey);
      var index = 0;
      tabGroup.items.forEach(function (com) {
        var comKey = com.key;

        if (comKey) {
          var item = self.createVisibleItem(comKey, metaKey, VisibleItem.Column, com.visible, com.visibleDependency);
          var pos = new ExprItemPos();
          pos.setIndex(index);
          item.setPos(pos);
          itemSet.add(item);
        }

        index++;
      });
      tree.add(itemSet);
    }
  },
  doCheckItemInit: function doCheckItemInit(meta) {}
});

_yesCore.YIUI.ExprHandlerMap.getInstance().reg(_yesCore.YIUI.CONTROLTYPE.CONTAINER, ContainerExprHandler);