"use strict";

var _yesCore = require("yes-core");

require("./defaultexprhandler");

require("./containerexprhandler");

require("./gridexprhandler");

require("./listviewexprhandler");

require("./tabgroupexprhandler");

require("./tableviewexprhandler");

var _formdepend = _interopRequireDefault(require("./formdepend"));

var _YIUIParser = require("yes-core/dist/YIUI-parser");

var _YIUICommon = require("yes-core/dist/YIUI-common");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

_yesCore.DataDef.Document.prototype.keys = function () {
  return this.maps.keys();
};

_yesCore.YIUI.RowCountUtil = function () {
  var Return = {
    getRowCountKey: function getRowCountKey(tableKey) {
      return tableKey + "_RowCount";
    },
    getTotalRowCountKey: function getTotalRowCountKey(tableKey) {
      return tableKey + "_TotalRowCount";
    },
    getRowCount: function getRowCount(doc, tableKey) {
      return _yesCore.YIUI.TypeConvertor.toInt(doc.getExpData(this.getRowCountKey(tableKey)));
    },
    getTotalRowCount: function getTotalRowCount(doc, tableKey) {
      var data = doc.getExpData(this.getTotalRowCountKey(tableKey));
      return data != undefined ? _yesCore.YIUI.TypeConvertor.toInt(data) : -1;
    },
    setRowCount: function setRowCount(doc, tableKey, rowCount) {
      var key = this.getRowCountKey(tableKey);
      doc.putExpData(key, rowCount);
      doc.expDataType[key] = _yesCore.YIUI.ExpandDataType.LONG;
    },
    setTotalRowCount: function setTotalRowCount(doc, tableKey, rowCount) {
      var key = this.getTotalRowCountKey(tableKey);
      doc.putExpData(key, rowCount);
      doc.expDataType[key] = _yesCore.YIUI.ExpandDataType.LONG;
    },
    rmTotalRowCount: function rmTotalRowCount(doc, tableKey) {
      var key = this.getTotalRowCountKey(tableKey);
      doc.rmExpData(key, key);
    }
  };
  return Return;
}();

_yesCore.YIUI.Form.prototype.oldinit = _yesCore.YIUI.Form.prototype.init;

_yesCore.YIUI.Form.prototype.init = function (metaForm, formID) {
  this.oldinit(metaForm, formID);
  this.dependency = new _formdepend["default"](this);
  this.dependency.build();
};

if (!Array.prototype.removeElement) {
  Array.prototype.removeElement = function (val) {
    var index = this.indexOf(val);

    if (index > -1) {
      this.splice(index, 1);
    }
  };
}

Array.prototype.add = function (obj) {
  return this.push(obj);
};

_yesCore.YIUI.MetaForm.prototype.oldinit = _yesCore.YIUI.MetaForm.prototype.init;

_yesCore.YIUI.MetaForm.prototype.init = function (jsonObj) {
  this.oldinit(jsonObj);
  this.operations = [];
  var operationCollection = jsonObj['operationCollection'];

  if (operationCollection) {
    this.operations = operationCollection.items.concat();
  }

  var uiCheckRuleCollection = jsonObj['uiCheckRuleCollection'];

  if (uiCheckRuleCollection) {
    this.uichecks = uiCheckRuleCollection.slice();
  }
};

_YIUIParser.Expr.Lexer = function (s) {
  this.s = s;
  this.len = s ? s.length : 0;
  this.li = null;
  this.lv = null;
  this.flv = null;
  this.type = -1;
  this.start = -1;
  this.pos = 0;
  this.b_skip = false;
  this.c_skip = false;
  this.obj = -1;
  this.err = -1;
  this.lastID = -1;
};

_YIUICommon.Lang.impl(_YIUIParser.Expr.Lexer, {
  setContent: function setContent(s) {
    this.s = s;
    this.pos = 0;
    this.len = s.length;
  },
  skipB: function skipB(c) {
    var r = c;
    this.b_skip = false;

    while (c == ' ' || c == '\t' || c == '\n' || c == '\r') {
      this.b_skip = true;

      if (this.pos < this.len) {
        c = this.s.charAt(this.pos);
      } else {
        this.err = -1;
        return r;
      }

      r = c;
      ++this.pos;
      ++this.start;
    }

    return r;
  },
  skipC: function skipC(c) {
    var r = c;
    this.c_skip = false;

    if (this.pos < this.len) {
      var oldPos = this.pos;
      var oldStart = this.start;
      var found = false;

      if (c == '/') {
        if (this.pos < this.len) {
          c = this.s.charAt(this.pos);
          ++this.pos;
          ++this.start;

          if (c == '/') {
            if (this.pos < this.len) {
              c = this.s.charAt(this.pos);
              ++this.pos;
              ++this.start;

              while (c != '\n' && this.pos < this.len) {
                if (this.pos < this.len) {
                  c = this.s.charAt(this.pos);
                  ++this.pos;
                  ++this.start;
                }
              }

              if (this.pos < this.len) {
                c = this.s.charAt(this.pos);
                ++this.pos;
                ++this.start;
                r = c;
              } else {
                r = '$';
              }

              found = true;
            }
          } else if (c == '*') {
            if (this.pos < this.len) {
              c = this.s.charAt(this.pos);
              ++this.pos;
              ++this.start;

              while (true) {
                if (c == '*') {
                  if (this.pos < this.len && this.s.charAt(this.pos) == '/') {
                    ++this.pos;
                    ++this.start;
                    found = true;
                    break;
                  }
                }

                if (this.pos < this.len) {
                  c = this.s.charAt(this.pos);
                  ++this.pos;
                  ++this.start;
                } else {
                  break;
                }
              }

              if (found) {
                if (this.pos < this.len) {
                  c = this.s.charAt(this.pos);
                  ++this.pos;
                  ++this.start;
                  r = c;
                } else {
                  r = '$';
                }
              }
            }
          }
        }
      }

      if (!found) {
        this.pos = oldPos;
        this.start = oldStart;
      } else {
        this.c_skip = true;
      }
    }

    return r;
  },
  lookSemi: function lookSemi() {
    var id = 26;
    var oldPos = this.pos;
    var c = ' ';

    if (this.pos < this.len) {
      c = this.s.charAt(this.pos);
      ++this.pos;

      do {
        c = this.skipB(c);

        if (this.err == -1) {
          return -1;
        }

        c = this.skipC(c);
        c = this.skipB(c);

        if (this.err == -1) {
          return -1;
        }
      } while (this.b_skip || this.c_skip);

      if (c == '}') {
        id = 28;
        this.li = "}";
        this.lv = "}";
        return id;
      } else {
        this.pos = oldPos;
      }
    } else {
      id = -1;
    }

    return id;
  },
  lookahead: function lookahead(ahc) {
    var oldPos = this.pos;
    var c = ' ';

    if (this.pos < this.len) {
      c = this.s.charAt(this.pos);
      ++this.pos;

      do {
        c = this.skipB(c);

        if (this.err == -1) {
          return false;
        }

        c = this.skipC(c);
        c = this.skipB(c);

        if (this.err == -1) {
          return false;
        }
      } while (this.b_skip || this.c_skip);

      if (c == ahc) {
        this.pos = oldPos;
        return true;
      } else {
        this.pos = oldPos;
      }
    }

    this.pos = oldPos;
    return false;
  },
  neg: function neg() {
    return this.lastID === -1 || this.lastID >= 0 && this.lastID <= 13 || this.lastID === 17 || this.lastID === 19;
  },
  resolveConst: function resolveConst(t) {
    if (_YIUIParser.Expr.eq(t.toLowerCase(), "true")) {
      this.lv = "true";
      this.type = _YIUIParser.Expr.T_BOOL;
      return 16;
    } else if (_YIUIParser.Expr.eq(t.toLowerCase(), "false")) {
      this.lv = "false";
      this.type = _YIUIParser.Expr.T_BOOL;
      return 16;
    }

    return -1;
  },
  resolveID: function resolveID(t) {
    var idx = t.indexOf('.');

    if (idx > 0) {
      var first = t.substring(0, idx);
      var second = t.substring(idx + 1);
      this.flv = t;
      t = second;
      this.obj = first;
      this.lv = second;
    } else {
      this.obj = null;
      this.lv = t;
      this.flv = t;
    }

    var id = -1;

    if (_YIUIParser.Expr.eq(t, "if")) {
      id = 21;
    } else if (_YIUIParser.Expr.eq(t, "else")) {
      id = 22;
    } else if (_YIUIParser.Expr.eq(t, "while")) {
      id = 23;
    } else if (_YIUIParser.Expr.eq(t, "var")) {
      id = 24;
    } else if (_YIUIParser.Expr.eq(t, "return")) {
      id = 29;
    } else if (_YIUIParser.Expr.eq(t, "break")) {
      id = 30;
    } else if (_YIUIParser.Expr.eq(t, "loop")) {
      id = 31;
    } else if (_YIUIParser.Expr.eq(t, "switch")) {
      id = 33;
    } else if (_YIUIParser.Expr.eq(t, "case")) {
      id = 34;
    }

    return id;
  },
  next: function next(slAsString) {
    this.err = 0;
    this.obj = null;
    this.flv = null;
    var oldPos = this.pos;
    var id = -1;
    var c;
    this.start = this.pos;
    if (this.pos >= this.len) return -1;
    c = this.s.charAt(this.pos);
    ++this.pos;

    do {
      c = this.skipB(c);

      if (this.err == -1) {
        return -1;
      }

      c = this.skipC(c);
      c = this.skipB(c);

      if (this.err == -1) {
        return -1;
      }
    } while (this.b_skip || this.c_skip);

    var cnt = 1;

    switch (c) {
      case '+':
        id = 0;
        this.li = "+";
        this.lv = "+";
        break;

      case '-':
        if (this.neg()) {
          var tmpC = ' ';

          if (this.pos < this.len) {
            tmpC = this.s.charAt(this.pos);
          }

          if (tmpC >= '0' && tmpC <= '9') {
            var isInt = true;

            if (this.pos < this.len) {
              c = this.s.charAt(this.pos);
            }

            while (c >= '0' && c <= '9' || c == '.') {
              if (c == '.') isInt = false;
              ++cnt;
              ++this.pos;

              if (this.pos >= this.len) {
                break;
              }

              c = this.s.charAt(this.pos);
            }

            id = 16;
            this.li = "const";
            this.lv = this.s.substring(this.start, this.start + cnt);
            if (isInt) {
              if (this.lv.length > 10) {
                this.type = _YIUIParser.Expr.T_NUM;
              } else {
                this.type = _YIUIParser.Expr.T_INT;
              }
            } else this.type = _YIUIParser.Expr.T_NUM;
          } else {
            id = 2;
            this.li = "-";
            this.lv = "-";
          }
        } else {
          id = 2;
          this.li = "-";
          this.lv = "-";
        }

        break;

      case '*':
        id = 3;
        this.li = "*";
        this.lv = "*";
        break;

      case '/':
        id = 4;
        this.li = "/";
        this.lv = "/";
        break;

      case '(':
        id = 17;
        this.li = "(";
        this.lv = "(";
        break;

      case '{':
        if (slAsString) {
          var deep = 1;

          do {
            if (this.pos < this.len) {
              c = this.s.charAt(this.pos);

              if (c == '{') {
                ++deep;
              } else if (c == '}') {
                --deep;
              }

              ++this.pos;
              ++cnt;
            } else {
              this.err = 1;
              return -1;
            }
          } while (c != '}' || deep != 0);

          id = 16;
          this.type = _YIUIParser.Expr.T_STR;
          this.li = "const";
          this.lv = this.s.substring(this.start + 1, this.start + cnt - 1);
        } else {
          id = 27;
          this.li = "{";
          this.lv = "{";
        }

        break;

      case ')':
        id = 18;
        this.li = ")";
        this.lv = ")";
        break;

      case '}':
        id = 28;
        this.li = "}";
        this.lv = "}";
        break;

      case ',':
        id = 19;
        this.li = ",";
        this.lv = ",";
        break;

      case ';':
        id = 26;
        this.li = ";";
        this.lv = ";";
        id = this.lookSemi();
        break;

      case '!':
        if (this.pos < this.len) {
          c = this.s.charAt(this.pos);

          if (c == '=') {
            id = 9;
            this.li = "<>";
            this.lv = "<>";
            ++this.pos;
          } else {
            id = 25;
            this.li = "!";
            this.lv = "!";
          }
        } else {
          id = 25;
          this.li = "!";
          this.lv = "!";
        }

        break;

      case '=':
        if (this.pos < this.len) {
          c = this.s.charAt(this.pos);

          if (c == '=') {
            id = 7;
            this.li = "==";
            this.lv = "==";
            ++this.pos;
          } else {
            id = 8;
            this.li = "=";
            this.lv = "=";
          }
        } else {
          id = 8;
          this.li = "=";
          this.lv = "=";
        }

        break;

      case '&':
        if (this.pos < this.len) {
          c = this.s.charAt(this.pos);

          if (c == '&') {
            id = 6;
            this.li = "&&";
            this.lv = "&&";
            ++this.pos;
          } else {
            id = 1;
            this.li = "&";
            this.lv = "&";
          }
        } else {
          id = 1;
          this.li = "&";
          this.lv = "&";
        }

        break;

      case '|':
        id = -1;

        if (this.pos < this.len) {
          c = this.s.charAt(this.pos);

          if (c == '|') {
            id = 5;
            this.li = "||";
            this.lv = "||";
            ++this.pos;
          }
        }

        break;

      case '>':
        if (this.pos < this.len) {
          c = this.s.charAt(this.pos);

          if (c == '=') {
            id = 11;
            this.li = ">=";
            this.lv = ">=";
            ++this.pos;
          } else {
            id = 10;
            this.li = ">";
            this.lv = ">";
          }
        } else {
          id = 10;
          this.li = ">";
          this.lv = ">";
        }

        break;

      case '<':
        if (this.pos < this.len) {
          c = this.s.charAt(this.pos);

          if (c == '=') {
            id = 13;
            this.li = "<=";
            this.lv = "<=";
            ++this.pos;
          } else if (c == '>') {
            id = 9;
            this.li = "<>";
            this.lv = "<>";
            ++this.pos;
          } else {
            id = 12;
            this.li = "<";
            this.lv = "<";
          }
        } else {
          id = 12;
          this.li = "<";
          this.lv = "<";
        }

        break;

      case '\'':
        do {
          if (this.pos < this.len) {
            c = this.s.charAt(this.pos);
            ++this.pos;
            ++cnt;
          } else {
            this.err = 1;
            return -1;
          }
        } while (c != '\'');

        id = 16;
        this.li = "const";
        this.type = _YIUIParser.Expr.T_STR;
        this.lv = this.s.substring(this.start + 1, this.start + cnt - 1);
        break;

      case '"':
        do {
          if (this.pos < this.len) {
            c = this.s.charAt(this.pos);
            ++this.pos;
            ++cnt;
          } else {
            this.err = 1;
            return -1;
          }
        } while (c != '"');

        id = 16;
        this.type = _YIUIParser.Expr.T_STR;
        this.li = "const";
        this.lv = this.s.substring(this.start + 1, this.start + cnt - 1);
        break;

      case ':':
        id = 35;
        this.li = ":";
        this.lv = ":";
        break;

      default:
        if (c >= 'A' && c <= 'Z' || c >= 'a' && c <= 'z') {
          var hasColon = false;

          if (this.pos < this.len) {
            c = this.s.charAt(this.pos);

            while (c >= 'A' && c <= 'Z' || c >= 'a' && c <= 'z' || c >= '0' && c <= '9' || c == '.' || c == '_' || c == ':') {
              if (c == ':') {
                hasColon = true;
              }

              ++cnt;
              ++this.pos;

              if (this.pos >= this.len) {
                break;
              }

              c = this.s.charAt(this.pos);
            }
          }

          if (hasColon) {
            id = 32;
            this.li = "range";
            this.lv = this.s.substring(this.start, this.start + cnt);
          } else {
            id = 15;
            this.li = "id";
            this.lv = this.s.substring(this.start, this.start + cnt);
            var nID = -1;
            nID = this.resolveConst(this.lv);

            if (nID != -1) {
              id = nID;
              this.li = "const";
            } else {
              nID = this.resolveID(this.lv);

              if (nID != -1) {
                id = nID;
                this.li = this.lv;
              } else {
                if (this.lookahead('(')) {
                  id = 14;
                  this.li = "fun";
                }
              }
            }
          }
        } else if (c >= '0' && c <= '9') {
          var isInteger = true;

          if (this.pos < this.len) {
            c = this.s.charAt(this.pos);

            while (c >= '0' && c <= '9' || c == '.') {
              if (c == '.') isInteger = false;
              ++cnt;
              ++this.pos;

              if (this.pos >= this.len) {
                break;
              }

              c = this.s.charAt(this.pos);
            }
          }

          id = 16;

          if (isInteger) {
            this.type = _YIUIParser.Expr.T_INT;
          } else {
            this.type = _YIUIParser.Expr.T_NUM;
          }

          this.li = "const";
          this.lv = this.s.substring(this.start, this.start + cnt);
        }

        break;
    } // 如果上次的符号是}，那么如果符号不是(-1)、(;)、(else)、(})，则需要补充(;)，此时需要回退输出缓冲区


    if (this.lastID == _YIUIParser.Expr.R_BR) {
      if (id != -1 && id != _YIUIParser.Expr.SEMI && id != _YIUIParser.Expr.ELSE && id != _YIUIParser.Expr.R_BR) {
        id = _YIUIParser.Expr.SEMI;
        this.li = ";";
        this.lv = ";";
        this.pos = oldPos;
      }
    }

    this.lastID = id;
    return id;
  },
  getLexID: function getLexID() {
    return this.li;
  },
  getLexValue: function getLexValue() {
    return this.lv;
  },
  getFullLexValue: function getFullLexValue() {
    return this.flv;
  },
  getType: function getType() {
    return this.type;
  },
  getErr: function getErr() {
    return this.err;
  },
  getObj: function getObj() {
    return this.obj;
  }
});