"use strict";

var _yesCore = require("yes-core");

require("./exprhandlermap");

require("./baseexprhandler");

var TabGroupExprHandler = _yesCore.YIUI.extend(_yesCore.YIUI.BaseExprHandler, {
  doCalcItemInit: function doCalcItemInit(meta) {},
  doEnableItemInit: function doEnableItemInit(meta) {},
  doVisibleItemInit: function doVisibleItemInit(meta, tree) {
    var self = this;
    var metaKey = meta.key;

    if (metaKey) {
      var item = self.createVisibleItem(metaKey, metaKey, VisibleItem.Head, meta.visible, meta.visibleDependency);
      tree.add(item);
      var items = meta.items;

      if (items) {
        items.forEach(function (item) {
          var comKey = item.key;

          if (comKey) {
            var item = self.createVisibleItem(comKey, metaKey, VisibleItem.Head, item.visible, item.visibleDependency);
            tree.add(item);
          }
        });
      }
    }
  },
  doCheckItemInit: function doCheckItemInit(meta) {}
});

_yesCore.YIUI.ExprHandlerMap.getInstance().reg(_yesCore.YIUI.CONTROLTYPE.TABGROUP, TabGroupExprHandler);